AJS.$.namespace("GH.gadget.rapid.fields");

/**
 * Rapid view picker.
 * 
 * @param rapidViewIdUserPref the id under which the project is stored
 * @param projectOptions the result of the ajax call that provides the available projects
 */
GH.gadget.rapid.fields.rapidViewPicker = function(gadget, rapidViewIdUserPref, rapidViewOptions)
{
	return {
        userpref: rapidViewIdUserPref,
        label: "Rapid View", //gadget.getMsg("gadget.common.project.label"),
        id: "rapid_view_picker_" + rapidViewIdUserPref,
        type: "callbackBuilder",
        callback: function (parentDiv)
        {
    		// add a project options box and description. Note that the label has already been added 
            parentDiv.append(
                AJS.$("<select/>").attr({
                    id: rapidViewIdUserPref,
                    name: rapidViewIdUserPref
                }).addClass('select')
            );
            			            
            // now fill the project list with values
            var $rapidViewSelectList = AJS.$("#" + rapidViewIdUserPref);
            $rapidViewSelectList.empty();

            //append the options to the rapidViewPicker, selecting the currently selected project
            var rapidViewIdUserPrefValue = gadget.getPref(rapidViewIdUserPref);
            AJS.$(rapidViewOptions).each(function()
            {
                var rapidViewOption = AJS.$("<option/>").attr("value", this.id).text(this.name);
                $rapidViewSelectList.append(rapidViewOption);
                if (this.id == rapidViewIdUserPrefValue)
                {
                	rapidViewOption.attr({selected: "selected"});
                }
            });
        }
    };
}

