/**
 * Encapsulates cookie utility methods
 * 
 * by @ded - http://www.dustindiaz.com/top-ten-javascript
 */
GH.Cookie = {};

/**
 * Get a cookie given its name
 */
GH.Cookie.getCookie = function( name ) {	
	var start = document.cookie.indexOf( name + "=" );
	var len = start + name.length + 1;
	if ( ( !start ) && ( name != document.cookie.substring( 0, name.length ) ) ) {
		return null;
	}
	if ( start == -1 ) return null;
	var end = document.cookie.indexOf( ';', len );
	if ( end == -1 ) end = document.cookie.length;
	return unescape( document.cookie.substring( len, end ) );
};

/**
 * Set a cookie.
 * 
 * @param name cookie name
 * @param value value to set for this cookie
 * @param expires days until cookie expiration
 * @param path path this cookie applies to
 * @param domain domain this cookie applies to
 * @param secure whether this is for https only, false for http and https
 */
GH.Cookie.setCookie = function( name, value, expires, path, domain, secure ) {
	var today = new Date();
	today.setTime( today.getTime() );
	if ( expires ) {
		expires = expires * 1000 * 60 * 60 * 24;
	}
	var expires_date = new Date( today.getTime() + (expires) );
	document.cookie = name+'='+escape( value ) +
		( ( expires ) ? ';expires='+expires_date.toGMTString() : '' ) + //expires.toGMTString()
		( ( path ) ? ';path=' + path : '' ) + 
		( ( domain ) ? ';domain=' + domain : '' ) +
		( ( secure ) ? ';secure' : '' );
};

/**
 * Delete a cookie
 */
GH.Cookie.deleteCookie = function( name, path, domain ) {
	if ( GH.Cookie.getCookie( name ) ) document.cookie = name + '=' +
			( ( path ) ? ';path=' + path : '') +
			( ( domain ) ? ';domain=' + domain : '' ) +
			';expires=Thu, 01-Jan-1970 00:00:01 GMT';
};
