// Rewrite JIRA 4.3 namespace locations to JIRA 4.2 namespace locations
// Allows us to run 4.2 build on 4.3 for now
if(!AJS.FlexiPopup) AJS.FlexiPopup = JIRA.Dialog;
if(!JIRA.DIALOGS) JIRA.DIALOGS = JIRA.Dialogs;
if(!AJS.FormPopup) AJS.FormPopup = JIRA.FormDialog;
if(!AJS.LabelsPopup) AJS.LabelsPopup = JIRA.LabelsDialog;
if(!AJS.SecurityLevelMenu) AJS.SecurityLevelMenu = AJS.SecurityLevelSelect;
if(!AJS.IssuePicker) AJS.IssuePicker = JIRA.IssuePicker;
if(!AJS.QueryableDropdown) AJS.QueryableDropdown = AJS.QueryableDropdownSelect;

if(!jira.app.issueoperations) jira.app.issueoperations = JIRA.Issue;
if(!jira.setFocus) jira.setFocus = JIRA.setFocus;
if(!jira.app.session) jira.app.session = {};
if(!jira.app.session.storage) jira.app.session.storage = JIRA.SessionStorage;


/******************************************************************/
/********************** GH.UTIL JAVASCRIPT  ************************/
/******************************************************************/
var GH = {};
GH.VERSION = '4.0';
GH.Util =
{
    doSubmit:function(evt, func){
    	var charCode = (evt.which) ? evt.which : evt.keyCode; 
    	if(charCode == 13) eval(func);
    },
	show: function(id){ if($(id)){Element.show($(id));} },
	hide: function(id){ if($(id)){Element.hide($(id));} },
	showAll: function(ids){ ids.each(function(id){GH.Util.show(id);}); },
	hideAll: function(ids){ ids.each(function(id){GH.Util.hide(id);}); },
	switchView: function(switchShow, switchHide){ GH.Util.hide(switchHide); GH.Util.show(switchShow); },
	isVisible: function(id){ return $(id) && Element.visible($(id)); },
	stopObserving: function(id, name, handler){if($(id)){Event.stopObserving(id, name, handler);}},
	innerValue: function(id){ return ($(id) ? $(id).innerHTML : '');},
	write: function(id, content){ if($(id)){$(id).innerHTML = content; }},
	highLight: function(id, time){ if($(id)){new Effect.Highlight($(id), {duration:time,queue:'parallel'});}},
	setClassName: function(id, className){ if($(id)){$(id).className = className; }},
	addClassName: function(id, className){ if($(id)){$(id).addClassName(className); }},
	removeClassName: function (id, className){ if($(id)){$(id).removeClassName(className); }},
	removeClassNames: function (id, classNames){ AJS.$("#"+id).removeClass(classNames); },
	hasClassName: function (id, className){ return $(id) && $(id).hasClassName(className); },
    innerWidth: function(id){ return AJS.$("#"+id).innerWidth()},
	insertTop: function (id, insertion){ if($(id)){new Insertion.Top($(id), insertion);}},
	setBackground: function(id, bcColor){ if($(id)){$(id).style.backgroundColor = bcColor;}},
	setValue:function(id, value){ if($(id)){$(id).value = value; }},
	resetValues:function(ids){ids.each(function(id){GH.Util.setValue(id, '');});},
	setValueWithHTML:function(id, htmlId){ if($(id)){$(id).value=GH.Util.trim(GH.Util.innerValue(htmlId)); }},
	destroy:function(id){ if($(id)){ $(id).remove(); }},
	trim:function(s){ 
		if(!s)return ""; 
		s = s.replace( /^\s+/g, "" ); 
		s = s.replace( /&lt;/g, "<" ); 
		s = s.replace( /&gt;/g, ">" ); 
		return s; 
	},
	findPos: function(id){ return [AJS.$("#"+id).position().left,AJS.$("#"+id).position().top];},
    scrollTop: function(){return AJS.$(window).scrollTop();},
    getPopup:function(popupId, left, top, z){$(popupId).style.top=top+'px';$(popupId).style.left=left+'px';$(popupId).style.position="absolute";$(popupId).style.visibility="visible";if(z){$(popupId).style.zIndex=z;} return $(popupId);},
	toDate:function(s){ var d = '';	for(var i=0; i<s.length; i++){ if((s.charAt(i) >= "0") && (s.charAt(i) <= "9")){ var j=i; while((s.charAt(j) >= "0") && (s.charAt(j) <= "9") && j<s.length) d=d+s.charAt(j++); d=d+s.charAt(j+1)+' '; i=j+2; } } return d; },
	toggle:function(id){if($(id)){if($F(id)){$(id).checked='';}else{$(id).checked='checked';} }},
	setValue: function(id, value) {if ($(id)) $(id).value = value; },
	selectionText: function(element){return element.options[element.selectedIndex].text;},
	forceWidth: function(id , size){if(!!(window.attachEvent && !window.opera)) $(id).style.width=size;},
	isFireFox:function(){return navigator.userAgent && navigator.userAgent.indexOf("Firefox") != -1;},
	windownDim: function() {
	  return [AJS.$(window).width(), AJS.$(window).height()];
	},
	openWindow:function(url, title){return window.open(url,title,"location=0,left=" + ((this.windownDim[0] - 800)/2) + ",top=" + ((this.windownDim[1] - 600)/2) + ",width=820px,height=600px,menubar=1,resizable=1,toolbar=0,scrollbars=1");},
	charCounter: function(event, id, max, counterId){ 
		var fieldValue = AJS.$('#' +id).val();
		if(fieldValue.length > max) $(id).value = fieldValue.substring(0, max);
		this.jsReplaceAll(counterId, "" + (max - fieldValue.length));
		return false;
	},
	jsReplaceAll: function(id, html) {
		AJS.$('#' + id).each(function() {
			var newEl = this.cloneNode(false);
			newEl.innerHTML = html;
			this.parentNode.replaceChild(newEl, this);
			return false;
			//Replace with clone instead of removing elements. Does not copy events in IE... but for our uses thats okay
		});
	},
	verifyKeyCode: function(evt){
		var charCode = (evt.which) ? evt.which : evt.keyCode;
		if (charCode == 8 || charCode == 9){ return true; }
		if (charCode > 31 && charCode < 41){ return true; }
		if (charCode > 43 && charCode < 60){ return true; }
		if (charCode > 64 && charCode < 91){ return true; }
		if (charCode > 94 && charCode < 123){ return true; }
		return false;
	},
	isSelectionModifier: function(e){
		var mac = (navigator.appVersion.indexOf("Mac")!==-1) ? true : false;
		return e.ctrlKey || ((mac && e.metaKey) || (!mac && e.altKey));
	},
	stopPropagationFor:function(action, ids){
		ids.each(function(id){Event.observe($(id), action, GH.Util.stopPropagation);});
	},
	stopPropagation:function(e)
	{
		if(!e) var e = window.event;	
		e.cancelBubble = true;
		e.returnValue = false;	
		if (e.stopPropagation) {
			e.stopPropagation();
			e.preventDefault();
		}
	},
	verifyNumInput:function(evt){
		var charCode = (evt.which) ? evt.which : evt.keyCode;
		if(charCode == 8 || charCode == 46) return true; // Backspace, Delete
		else if(charCode > 34 && charCode < 41) return true; // Arrows, End, Home
		else return GH.Util.isNumKey(evt);
	},
	isNumKey:function(evt){
		var charCode = (evt.which) ? evt.which : evt.keyCode;
		if (charCode > 47 && charCode < 58){ return true; }
		return false;
	},
	toPath: function(string){ return string.replace(/\\/g, "/");},
	disableLinks: function(links) {
		if(!links) links = $$('a'); 
		links.invoke('observe', 'click', Event.stop);
	},
	find: function(expression, extend) {
		if (extend === false) Prototype.Tuning.extendOnCssSelect = false;
		var result = $$(expression);
		if (extend === false) Prototype.Tuning.extendOnCssSelect = true;
		return result;
	},
	/**
	 * IE doesn't pass the event on when using inline handlers, but rather attaches it to a
	 * global event variable
	 */
	getEvent: function(event) {
		if (Prototype.Browser.IE && !event) event = window.event;
		return Event.extend(event);
	}
};
Encoder = {
	EncodeType : "entity",
	isEmpty : function(val){
		if(val){
			return ((val===null) || val.length==0 || /^\s+$/.test(val));
		}else{
			return true;
		}
	},
	HTML2Numerical : function(s){
		var arr1 = new Array('&nbsp;','&iexcl;','&cent;','&pound;','&curren;','&yen;','&brvbar;','&sect;','&uml;','&copy;','&ordf;','&laquo;','&not;','&shy;','&reg;','&macr;','&deg;','&plusmn;','&sup2;','&sup3;','&acute;','&micro;','&para;','&middot;','&cedil;','&sup1;','&ordm;','&raquo;','&frac14;','&frac12;','&frac34;','&iquest;','&agrave;','&aacute;','&acirc;','&atilde;','&Auml;','&aring;','&aelig;','&ccedil;','&egrave;','&eacute;','&ecirc;','&euml;','&igrave;','&iacute;','&icirc;','&iuml;','&eth;','&ntilde;','&ograve;','&oacute;','&ocirc;','&otilde;','&Ouml;','&times;','&oslash;','&ugrave;','&uacute;','&ucirc;','&Uuml;','&yacute;','&thorn;','&szlig;','&agrave;','&aacute;','&acirc;','&atilde;','&auml;','&aring;','&aelig;','&ccedil;','&egrave;','&eacute;','&ecirc;','&euml;','&igrave;','&iacute;','&icirc;','&iuml;','&eth;','&ntilde;','&ograve;','&oacute;','&ocirc;','&otilde;','&ouml;','&divide;','&oslash;','&ugrave;','&uacute;','&ucirc;','&uuml;','&yacute;','&thorn;','&yuml;','&quot;','&amp;','&lt;','&gt;','&oelig;','&oelig;','&scaron;','&scaron;','&yuml;','&circ;','&tilde;','&ensp;','&emsp;','&thinsp;','&zwnj;','&zwj;','&lrm;','&rlm;','&ndash;','&mdash;','&lsquo;','&rsquo;','&sbquo;','&ldquo;','&rdquo;','&bdquo;','&dagger;','&dagger;','&permil;','&lsaquo;','&rsaquo;','&euro;','&fnof;','&alpha;','&beta;','&gamma;','&delta;','&epsilon;','&zeta;','&eta;','&theta;','&iota;','&kappa;','&lambda;','&mu;','&nu;','&xi;','&omicron;','&pi;','&rho;','&sigma;','&tau;','&upsilon;','&phi;','&chi;','&psi;','&omega;','&alpha;','&beta;','&gamma;','&delta;','&epsilon;','&zeta;','&eta;','&theta;','&iota;','&kappa;','&lambda;','&mu;','&nu;','&xi;','&omicron;','&pi;','&rho;','&sigmaf;','&sigma;','&tau;','&upsilon;','&phi;','&chi;','&psi;','&omega;','&thetasym;','&upsih;','&piv;','&bull;','&hellip;','&prime;','&prime;','&oline;','&frasl;','&weierp;','&image;','&real;','&trade;','&alefsym;','&larr;','&uarr;','&rarr;','&darr;','&harr;','&crarr;','&larr;','&uarr;','&rarr;','&darr;','&harr;','&forall;','&part;','&exist;','&empty;','&nabla;','&isin;','&notin;','&ni;','&prod;','&sum;','&minus;','&lowast;','&radic;','&prop;','&infin;','&ang;','&and;','&or;','&cap;','&cup;','&int;','&there4;','&sim;','&cong;','&asymp;','&ne;','&equiv;','&le;','&ge;','&sub;','&sup;','&nsub;','&sube;','&supe;','&oplus;','&otimes;','&perp;','&sdot;','&lceil;','&rceil;','&lfloor;','&rfloor;','&lang;','&rang;','&loz;','&spades;','&clubs;','&hearts;','&diams;');
		var arr2 = new Array('&#160;','&#161;','&#162;','&#163;','&#164;','&#165;','&#166;','&#167;','&#168;','&#169;','&#170;','&#171;','&#172;','&#173;','&#174;','&#175;','&#176;','&#177;','&#178;','&#179;','&#180;','&#181;','&#182;','&#183;','&#184;','&#185;','&#186;','&#187;','&#188;','&#189;','&#190;','&#191;','&#192;','&#193;','&#194;','&#195;','&#196;','&#197;','&#198;','&#199;','&#200;','&#201;','&#202;','&#203;','&#204;','&#205;','&#206;','&#207;','&#208;','&#209;','&#210;','&#211;','&#212;','&#213;','&#214;','&#215;','&#216;','&#217;','&#218;','&#219;','&#220;','&#221;','&#222;','&#223;','&#224;','&#225;','&#226;','&#227;','&#228;','&#229;','&#230;','&#231;','&#232;','&#233;','&#234;','&#235;','&#236;','&#237;','&#238;','&#239;','&#240;','&#241;','&#242;','&#243;','&#244;','&#245;','&#246;','&#247;','&#248;','&#249;','&#250;','&#251;','&#252;','&#253;','&#254;','&#255;','&#34;','&#38;','&#60;','&#62;','&#338;','&#339;','&#352;','&#353;','&#376;','&#710;','&#732;','&#8194;','&#8195;','&#8201;','&#8204;','&#8205;','&#8206;','&#8207;','&#8211;','&#8212;','&#8216;','&#8217;','&#8218;','&#8220;','&#8221;','&#8222;','&#8224;','&#8225;','&#8240;','&#8249;','&#8250;','&#8364;','&#402;','&#913;','&#914;','&#915;','&#916;','&#917;','&#918;','&#919;','&#920;','&#921;','&#922;','&#923;','&#924;','&#925;','&#926;','&#927;','&#928;','&#929;','&#931;','&#932;','&#933;','&#934;','&#935;','&#936;','&#937;','&#945;','&#946;','&#947;','&#948;','&#949;','&#950;','&#951;','&#952;','&#953;','&#954;','&#955;','&#956;','&#957;','&#958;','&#959;','&#960;','&#961;','&#962;','&#963;','&#964;','&#965;','&#966;','&#967;','&#968;','&#969;','&#977;','&#978;','&#982;','&#8226;','&#8230;','&#8242;','&#8243;','&#8254;','&#8260;','&#8472;','&#8465;','&#8476;','&#8482;','&#8501;','&#8592;','&#8593;','&#8594;','&#8595;','&#8596;','&#8629;','&#8656;','&#8657;','&#8658;','&#8659;','&#8660;','&#8704;','&#8706;','&#8707;','&#8709;','&#8711;','&#8712;','&#8713;','&#8715;','&#8719;','&#8721;','&#8722;','&#8727;','&#8730;','&#8733;','&#8734;','&#8736;','&#8743;','&#8744;','&#8745;','&#8746;','&#8747;','&#8756;','&#8764;','&#8773;','&#8776;','&#8800;','&#8801;','&#8804;','&#8805;','&#8834;','&#8835;','&#8836;','&#8838;','&#8839;','&#8853;','&#8855;','&#8869;','&#8901;','&#8968;','&#8969;','&#8970;','&#8971;','&#9001;','&#9002;','&#9674;','&#9824;','&#9827;','&#9829;','&#9830;');
		return this.swapArrayVals(s,arr1,arr2);
	},	

	NumericalToHTML : function(s){
		var arr1 = new Array('&#160;','&#161;','&#162;','&#163;','&#164;','&#165;','&#166;','&#167;','&#168;','&#169;','&#170;','&#171;','&#172;','&#173;','&#174;','&#175;','&#176;','&#177;','&#178;','&#179;','&#180;','&#181;','&#182;','&#183;','&#184;','&#185;','&#186;','&#187;','&#188;','&#189;','&#190;','&#191;','&#192;','&#193;','&#194;','&#195;','&#196;','&#197;','&#198;','&#199;','&#200;','&#201;','&#202;','&#203;','&#204;','&#205;','&#206;','&#207;','&#208;','&#209;','&#210;','&#211;','&#212;','&#213;','&#214;','&#215;','&#216;','&#217;','&#218;','&#219;','&#220;','&#221;','&#222;','&#223;','&#224;','&#225;','&#226;','&#227;','&#228;','&#229;','&#230;','&#231;','&#232;','&#233;','&#234;','&#235;','&#236;','&#237;','&#238;','&#239;','&#240;','&#241;','&#242;','&#243;','&#244;','&#245;','&#246;','&#247;','&#248;','&#249;','&#250;','&#251;','&#252;','&#253;','&#254;','&#255;','&#34;','&#38;','&#60;','&#62;','&#338;','&#339;','&#352;','&#353;','&#376;','&#710;','&#732;','&#8194;','&#8195;','&#8201;','&#8204;','&#8205;','&#8206;','&#8207;','&#8211;','&#8212;','&#8216;','&#8217;','&#8218;','&#8220;','&#8221;','&#8222;','&#8224;','&#8225;','&#8240;','&#8249;','&#8250;','&#8364;','&#402;','&#913;','&#914;','&#915;','&#916;','&#917;','&#918;','&#919;','&#920;','&#921;','&#922;','&#923;','&#924;','&#925;','&#926;','&#927;','&#928;','&#929;','&#931;','&#932;','&#933;','&#934;','&#935;','&#936;','&#937;','&#945;','&#946;','&#947;','&#948;','&#949;','&#950;','&#951;','&#952;','&#953;','&#954;','&#955;','&#956;','&#957;','&#958;','&#959;','&#960;','&#961;','&#962;','&#963;','&#964;','&#965;','&#966;','&#967;','&#968;','&#969;','&#977;','&#978;','&#982;','&#8226;','&#8230;','&#8242;','&#8243;','&#8254;','&#8260;','&#8472;','&#8465;','&#8476;','&#8482;','&#8501;','&#8592;','&#8593;','&#8594;','&#8595;','&#8596;','&#8629;','&#8656;','&#8657;','&#8658;','&#8659;','&#8660;','&#8704;','&#8706;','&#8707;','&#8709;','&#8711;','&#8712;','&#8713;','&#8715;','&#8719;','&#8721;','&#8722;','&#8727;','&#8730;','&#8733;','&#8734;','&#8736;','&#8743;','&#8744;','&#8745;','&#8746;','&#8747;','&#8756;','&#8764;','&#8773;','&#8776;','&#8800;','&#8801;','&#8804;','&#8805;','&#8834;','&#8835;','&#8836;','&#8838;','&#8839;','&#8853;','&#8855;','&#8869;','&#8901;','&#8968;','&#8969;','&#8970;','&#8971;','&#9001;','&#9002;','&#9674;','&#9824;','&#9827;','&#9829;','&#9830;');
		var arr2 = new Array('&nbsp;','&iexcl;','&cent;','&pound;','&curren;','&yen;','&brvbar;','&sect;','&uml;','&copy;','&ordf;','&laquo;','&not;','&shy;','&reg;','&macr;','&deg;','&plusmn;','&sup2;','&sup3;','&acute;','&micro;','&para;','&middot;','&cedil;','&sup1;','&ordm;','&raquo;','&frac14;','&frac12;','&frac34;','&iquest;','&agrave;','&aacute;','&acirc;','&atilde;','&Auml;','&aring;','&aelig;','&ccedil;','&egrave;','&eacute;','&ecirc;','&euml;','&igrave;','&iacute;','&icirc;','&iuml;','&eth;','&ntilde;','&ograve;','&oacute;','&ocirc;','&otilde;','&Ouml;','&times;','&oslash;','&ugrave;','&uacute;','&ucirc;','&Uuml;','&yacute;','&thorn;','&szlig;','&agrave;','&aacute;','&acirc;','&atilde;','&auml;','&aring;','&aelig;','&ccedil;','&egrave;','&eacute;','&ecirc;','&euml;','&igrave;','&iacute;','&icirc;','&iuml;','&eth;','&ntilde;','&ograve;','&oacute;','&ocirc;','&otilde;','&ouml;','&divide;','&oslash;','&ugrave;','&uacute;','&ucirc;','&uuml;','&yacute;','&thorn;','&yuml;','&quot;','&amp;','&lt;','&gt;','&oelig;','&oelig;','&scaron;','&scaron;','&yuml;','&circ;','&tilde;','&ensp;','&emsp;','&thinsp;','&zwnj;','&zwj;','&lrm;','&rlm;','&ndash;','&mdash;','&lsquo;','&rsquo;','&sbquo;','&ldquo;','&rdquo;','&bdquo;','&dagger;','&dagger;','&permil;','&lsaquo;','&rsaquo;','&euro;','&fnof;','&alpha;','&beta;','&gamma;','&delta;','&epsilon;','&zeta;','&eta;','&theta;','&iota;','&kappa;','&lambda;','&mu;','&nu;','&xi;','&omicron;','&pi;','&rho;','&sigma;','&tau;','&upsilon;','&phi;','&chi;','&psi;','&omega;','&alpha;','&beta;','&gamma;','&delta;','&epsilon;','&zeta;','&eta;','&theta;','&iota;','&kappa;','&lambda;','&mu;','&nu;','&xi;','&omicron;','&pi;','&rho;','&sigmaf;','&sigma;','&tau;','&upsilon;','&phi;','&chi;','&psi;','&omega;','&thetasym;','&upsih;','&piv;','&bull;','&hellip;','&prime;','&prime;','&oline;','&frasl;','&weierp;','&image;','&real;','&trade;','&alefsym;','&larr;','&uarr;','&rarr;','&darr;','&harr;','&crarr;','&larr;','&uarr;','&rarr;','&darr;','&harr;','&forall;','&part;','&exist;','&empty;','&nabla;','&isin;','&notin;','&ni;','&prod;','&sum;','&minus;','&lowast;','&radic;','&prop;','&infin;','&ang;','&and;','&or;','&cap;','&cup;','&int;','&there4;','&sim;','&cong;','&asymp;','&ne;','&equiv;','&le;','&ge;','&sub;','&sup;','&nsub;','&sube;','&supe;','&oplus;','&otimes;','&perp;','&sdot;','&lceil;','&rceil;','&lfloor;','&rfloor;','&lang;','&rang;','&loz;','&spades;','&clubs;','&hearts;','&diams;');
		return this.swapArrayVals(s,arr1,arr2);
	},	
	numEncode : function(s){
		if(this.isEmpty(s)) return "";
		var e = "";
		for (var i = 0; i < s.length; i++)
		{
			var c = s.charAt(i);
			if (c < " " || c > "~")
			{
				c = "&#" + c.charCodeAt() + ";";
			}
			e += c;
		}
		return e;
	},
	htmlDecode : function(s){
		var c,m,d = s;
		if(this.isEmpty(d)) return "";
		d = this.HTML2Numerical(d);
		arr=d.match(/&#[0-9]{1,5};/g);
		if(arr!=null){
			for(var x=0;x<arr.length;x++){
				m = arr[x];
				c = m.substring(2,m.length-1);
				if(c >= -32768 && c <= 65535){
					d = d.replace(m, String.fromCharCode(c));
				}else{
					d = d.replace(m, "");
				}
			}			
		}
		return d;
	},		
	htmlEncode : function(s,dbl){
		if(this.isEmpty(s)) return "";
		dbl = dbl | false; //default to prevent double encoding
		if(dbl){
			if(this.EncodeType=="numerical"){
				s = s.replace(/&/g, "&#38;");
			}else{
				s = s.replace(/&/g, "&amp;");
			}
		}
		s = this.XSSEncode(s,false);
		if(this.EncodeType=="numerical" || !dbl){
			s = this.HTML2Numerical(s);
		}
		s = this.numEncode(s);
		if(!dbl){
			s = s.replace(/&#/g,"##AMPHASH##");
			if(this.EncodeType=="numerical"){
				s = s.replace(/&/g, "&#38;");
			}else{
				s = s.replace(/&/g, "&amp;");
			}
			s = s.replace(/##AMPHASH##/g,"&#");
		}
		s = s.replace(/&#\d*([^\d;]|$)/g, "$1");
		if(!dbl){
			s = this.correctEncoding(s);
		}
		if(this.EncodeType=="entity"){
			s = this.NumericalToHTML(s);
		}
		return s;					
	},
	XSSEncode : function(s,en){
		if(!this.isEmpty(s)){
			en = en || true;
			if(en){
				s = s.replace(/\'/g,"&#39;");
				s = s.replace(/\"/g,"&quot;");
				s = s.replace(/</g,"&lt;");
				s = s.replace(/>/g,"&gt;");
			}else{
				s = s.replace(/\'/g,"&#39;");
				s = s.replace(/\"/g,"&#34;");
				s = s.replace(/</g,"&#60;");
				s = s.replace(/>/g,"&#62;");
			}
			return s;
		}else{
			return "";
		}
	},
	stripUnicode : function(s){
		return s.replace(/[^\x20-\x7E]/g,"");
	},
	correctEncoding : function(s){
		return s.replace(/(&amp;)(amp;)+/,"$1");
	},
	swapArrayVals : function(s,arr1,arr2){
		if(this.isEmpty(s)) return "";
		var re;
		if(arr1 && arr2){
			if(arr1.length == arr2.length){
				for(var x=0,i=arr1.length;x<i;x++){
					re = new RegExp(arr1[x], 'g');
					s = s.replace(re,arr2[x]);
				}
			}
		}
		return s;
	},
	inArray : function( item, arr ) {
		for ( var i = 0, x = arr.length; i < x; i++ ){
			if ( arr[i] === item ){
				return i;
			}
		}
		return -1;
	}
};
/******************************************************************/
/********************** COOKIES JAVASCRIPT  ************************/
/******************************************************************/
var Cookie = Class.create();
Cookie.prototype = 
{
	initialize: function(name, domain, path, expires, secure) {
		this.name = name;
		this.expires = expires;
		this.domain = domain;
		this.path = path;
		this.secure = secure;
	  	this.data = this.buildData();
        this.store();
	},
	getData: function(key) {
		return this.data[key];
	},
	setData: function(key, value) {
        this.data[key] = value;
        this.store();
    },
    removeData: function(key) {
        delete this.data[key];
        this.store();
    },
    buildData: function() {
        var start = document.cookie.indexOf(this.name + "=");
        if(start == -1 || this.name != document.cookie.substr(start, this.name.length)) {
            return {};
        }

        var len = start + this.name.length + 1;   
        var end = document.cookie.indexOf(';', len);
        if(end == -1) {
            end = document.cookie.length;
        }

        return unescape(document.cookie.substring(len, end)).evalJSON();
    },
    store : function() {
        var expiry = '';
        if (this.expires) {
            var today = new Date();
            expiry = this.expires * 86400000;
            expiry = ';expires=' + new Date(today.getTime() + expiry);
        }

        document.cookie = this.name + '=' + escape(Object.toJSON(this.data)) + this.getOptions() + expiry;
    },
    erase: function() {
        document.cookie = this.name + '=' + this.getOptions() + ';expires=Thu, 01-Jan-1970 00:00:01 GMT';
    },
    getOptions: function() {
        return (this.path ? ';path=' + this.path : '') + (this.domain ? ';domain=' + this.domain : '');      
    }
};

/******************************************************************/
/********************** BOARDS JAVASCRIPT  ************************/
/******************************************************************/
var Pagination = Class.create();
Pagination.prototype = {
	initialize: function(){
		this.total = 0;
		this.currentPage = 0;
	},
	set:function(newTotal, newCurrentPage, tooltips){
		newTotal = newTotal > 1 ? newTotal : 0;
		this.currentPage = newCurrentPage <= newTotal && newCurrentPage > 0 ? newCurrentPage : 1;

		if(this.total > newTotal){
			for(var i = this.total; i > newTotal; i--){
				Event.stopObserving($("cp_" + i));
				$("cp_" + i).remove();
			}
		}
		else if(this.total < newTotal){
			for(var i = this.total; i < newTotal; i++){
				var number = i+1;
                var listItem = new Element('li');
                var listItemLink = new Element('a');
				listItemLink.id = "cp_" + number;
				listItemLink.title = tooltips[i];
				listItemLink.update(number);
                listItem.appendChild(listItemLink);
				$("gh-column-pagination").appendChild(listItem);
                GH.Util.addClassName(listItemLink, "button");
				if(number == this.currentPage){
					GH.Util.addClassName(listItemLink, "active");
				}
                Event.observe(listItemLink, 'click', Boards.colPagination.setPage);
			}
            AJS.$('#gh-column-pagination').removeClass('hidden');            
		}
        AJS.$('#gh-column-pagination li a').removeClass('first last').last().addClass('last').end().first().addClass('first'); // update first and last classes to include new arrivals - these make the buttons rounded, nice
        this.total = newTotal;
	},
	setPage: function(element, event){
		var el = element.element();
		var currentNumber = parseInt(el ? el.id.split("_")[1] : 1);

		if(currentNumber != Boards.colPagination.currentPage){
			Boards.colPagination.currentPage = currentNumber;
			$$("#gh-column-pagination li a").each(function(item){GH.Util.removeClassName(item, "active");});
			GH.Util.addClassName(el.id, "active");
			Boards.refreshColumn(Boards.colPagination.currentNumber);
		}
	},
	clean: function(){
		$$("#gh-column-pagination li a").each(function(item){Event.stopObserving(item);});
	}
};
var Boards = new function()
{
	this.ISSUE_PADDING = 40;
	this.waiting='';
	this.boards = $H();
	this.markers = $H();
	this.planningBoard;this.compactView;
	this.needsRefresh = this.inSearchMode = false;
	this.searchStart = this.callCount = this.clickCount = 0;
	this.draggedIssue, this.draggedMarker, this.winPicker, this.AJSpopup, this.droppedBoard; 
	this.colPagination = new Pagination();
	this.cookies = new Cookie("gh.i", "", "/", 90, false);
	this.pluginKey='com.pyxis.greenhopper.jira:greenhopper-webactions';
	this.pageType='';
	this.subType='';
	
	this.init=function(projectId, boardId, linkId, autoRefresh/* not used*/, delay/* not used*/, ctx, pageType, subType){
		this.selectedProjectId = projectId;
		this.linkId = linkId;
		this.ctx = ctx;
		this.mainBoard = Boards.boards.set(boardId, new Board(boardId));
		this.createDialogElements();
		// only set for new board implementation
		this.pageType = pageType ? pageType : '';
		this.subType = subType ? subType : '';
	};
	this.getBoard=function(id){
		return Boards.boards.get(id) ? Boards.boards.get(id) : Boards.boards.set(id, new Board(id));
	};
	this.getMarker=function(id){
		return Boards.markers.get(id) ? Boards.markers.get(id) : Boards.markers.set(id, new Marker(id));
	};
	this.removeBoard=function(id){
		try{
			Boards.boards.unset(id).clean();
		}catch(e){}
	};
	this.refreshOverview=function(){
		Boards.working();
		Boards.submit("RefreshOverview", $H({selectedProjectId:Boards.selectedProjectId, selectedBoardId:"-1"}));
	};
    this.findParent=function(event, boardId, parentKey){
        event = GH.Util.getEvent(event);
        if (!event.isMiddleClick()) {
            Boards.getBoard(boardId).selectOrFind(parentKey);
            event.stop();
            return false;
        }
    };
	this.ffocus=function(id){
		var elem = $(id);
		if(elem && !elem.disabled) elem.focus();
	};
	this.showPopup=function(id, offsets){
		if($(id+'-dd')){
			$(id+'-dd').setStyle({'left':offsets[0]+'px', 'top':offsets[1]+'px'});
			Boards.openWithShadow(id, [offsets[0]-8, offsets[1]]);
		}
		GH.Util.hideAll(['opt_wait', 'popup_wait', 'search_wait']);
	};
	this.modalPopup=function(type, id){
		Boards.dimAndMoveDialogElements();
		GH.Util.showAll(['dialog']);
		if(Boards.inSearchMode && type != 'search'){
			Boards.hideSearchPopup();
			GH.Util.showAll([type]);
		}
		else if (type == 'search') {
			GH.Util.hideAll(['waiting_display']);
			Boards._showSearchPopup();
		}
		else {
			GH.Util.switchView(type, 'waiting_display');
		}
		var parentTop = $(id+"-dd").parentNode.style.paddingTop;
		Boards.openWithShadow(id, [-8, parentTop.substring(0, parentTop.length - 2)]);
		if($('popup-scroll'))$('popup-scroll').scrollTop=0;
		GH.Util.hideAll(['opt_wait', 'popup_wait', 'search_wait', 'waiting_display']);
	};
	this.popup=function(id, width, anchor){
		if($(id+'-dd')){
			var offsetLeft = 0; var offsetTop = 0; 
			var baseElement = anchor && $(anchor) ? $(anchor) : $(id);
			var offEle = baseElement;
			while(offEle.offsetParent){
				offsetLeft += offEle.offsetLeft;
				offsetTop += offEle.offsetTop;
				offEle = offEle.offsetParent;
			}
			var left = offsetLeft - width/2;
			if(offsetLeft < width/2)
				left = 3;
			else if(GH.Util.windownDim()[0] - offsetLeft < width/2){
				left = GH.Util.windownDim()[0] - width - (GH.Util.isFireFox() ? 24 : 9);
			}
	    	var dtop = offsetTop + Element.getHeight(baseElement) + (Prototype.Browser.IE ? 3 : 2);
			baseElement = offEle = null;
			Boards.showPopup(id, [left, dtop]);
		}
		GH.Util.hideAll(['opt_wait', 'popup_wait', 'search_wait']);
	};
    this.openWithShadow=function(id, slide){
    	if(!$(id+'-dd') || $(id+'-dd').innerHTML=='')return;
    	GH.Util.setClassName(id+'-dd-s', "gh-shadow");
    	var width = $(id+'-dd').getWidth();
    	var height = $(id+'-dd').getHeight();
    	if(slide[0]!=null){
    		$(id+'-dd-s').setStyle({'top':slide[1]+'px', 'left':slide[0]+'px', 'width':(width+16)+'px', 'height':(height+14)+'px'});
    	}
    	else{
    		$(id+'-dd-s').setStyle({'top':slide[1]+'px', 'width':(width+16)+'px', 'height':(height+14)+'px'});
    	}
    	$(id+'-dd-s').innerHTML='<div class="tl"></div><div class="tr"></div><div class="l" style="height:'+(height-8)+'px;"></div><div class="r" style="height:'+(height-8)+'px;"></div><div class="bl"></div><div class="br"></div><div class="b" style="width:'+(width-12)+'px;"></div>';
    	GH.Util.showAll([id+'-dd', id+'-dd-s']);
    };
	this.popupError=function(){
		GH.Util.show('popuperrors');
		if($('popup-scroll'))$('popup-scroll').scrollTop=0;
	};
	this.getDropdownOptions=function(id, jspa){
		if($(id + "-options").innerHTML != '') return;
		GH.Util.addClassName(id + "-boards", "active");
		Boards.updater(id + "-options", jspa, $H({}), true, Boards.doneWorking);
	};
	this.editCapacity=function(fieldId){
		$(fieldId+'_max').value = $F(fieldId+'_maxValue');
		$(fieldId+'_min').value = $F(fieldId+'_minValue');
		GH.Util.switchView(fieldId+'Edit', fieldId+'Txt');
		GH.Util.switchView(fieldId+'Edit_links', fieldId+'Txt_links');
		Boards.ffocus(fieldId+'_min');
	};
	this.cancelCapacity=function(fieldId){
		GH.Util.switchView(fieldId+'Txt', fieldId+'Edit');
		GH.Util.switchView(fieldId+'Txt_links', fieldId+'Edit_links');
	};
	this.setCapacity=function(fieldId){
		GH.Util.show('Stats_wait');
		Boards.updater("statistics-table", "SetDefaultCapacity", $H({fieldId:fieldId, maxCapacity:$F(fieldId+'_max'), minCapacity:$F(fieldId+'_min') }), true, Boards.doneWorking);
	};
	this.addStats=function(){
		GH.Util.show('Stats_wait');
		Boards.updater("statistics-table", "AddStats", $H({fieldId:$F('statsSelect'), maxCapacity:$F('capacity_max'), minCapacity:$F('capacity_min')}), true, Boards.doneWorking);
	};
	this.removeStats=function(fieldId){
		GH.Util.show('Stats_wait');
		Boards.updater("statistics-table", "RemoveStats", $H({fieldId:fieldId}), true, Boards.doneWorking);
	};
	this.is=function(view){
		return $(view) ? true : false;
	};
	this.isPlanningBoard=function(){
		if(this.planningBoard==null) this.planningBoard = Boards.is('VersionBoard') || Boards.is('ComponentBoard') || Boards.is('AssigneeBoard') || Boards.is('BacklogBoard'); 
		return this.planningBoard;
	};
	this.isTaskBoard=function(){
		return Boards.is('TaskBoard') && !Boards.inSearchMode; 
	};
	this.isListView=function(){
		return Boards.inSearchMode ? GH.Util.hasClassName("search-results", "gh-list") : GH.Util.hasClassName("gh", "gh-list");
	};
	this.isCompactView=function(){
		if(this.compactView==null) this.compactView = ($('isCompactView') ? true : false); 
		return this.compactView;
	};
	this.markerUpHandler=function(e){
		if(Boards.draggedMarker && !GH.Util.isSelectionModifier(e) && !e.shiftKey){
			GH.Util.removeClassName(Boards.draggedMarker, 'gh-downunder');
		}
	};
	this.markerDownHandler=function(e){
		if(Boards.draggedMarker && (GH.Util.isSelectionModifier(e) || e.shiftKey)){
			GH.Util.addClassName(Boards.draggedMarker, 'gh-downunder');
		}
	};
	this.escapeHandler=function(event){
		if(event.keyCode == Event.KEY_ESC){
			// only activate if we are not in search mode. search handles cancelling separately
			if (! (Boards.inSearchMode && GH.Util.isVisible('search'))) {
				// cancel all edits
				Boards.boards.values().each(function(board){
					board.cancelEdit();
					board.issues.values().each(function(issue){
						issue.cancelEdit();
					});
				});
			}
		}
	};
	this.searchPopupEscapeHandler=function(event){
		// hide the search dialog if displayed, but only if any other dialog is displayed on top of it
		if(event.keyCode == Event.KEY_ESC){
			if (Boards.inSearchMode && GH.Util.isVisible('search')) {
				// first check whether any edits are ongoing - we don't want to close the dialog in that case
				var SEARCH_BOARD_ID = 10;
				var searchBoard = Boards.getBoard(SEARCH_BOARD_ID);
				var close = true;
				searchBoard.issues.values().each(function(issue){
					if (issue.isEditing()) {
						close = false;
						issue.cancelEdit();
					}
				});
				if (close) {
					Boards.closePopup();
				}
				// swallow the event as otherwise firefox sometimes fails to execute pending ajax requests if we let the event continue bubbling up
				Event.stop(event);
			}
		}
	};
    this.screenSizeHandler=function(){
    	// Evade IE window.onResize bug
    	if (Boards.draggedIssue) return; 
        var PB_ISSUE_PADDING = 9,
            TB_ISSUE_PADDING = 14,
            TB_COL_PADDING = 11,
            SCROLL_SPACE = 15,
            DEFAULT = 0,
            PB = 0;
        
        GH.Util.removeClassNames('gh', 'gh-dyn-1 gh-dyn-2 gh-dyn-3 gh-dyn-4 gh-dyn-5 gh-dyn-6 gh-dyn-over');
        var screenSpace = GH.Util.innerWidth("gh-content-inner") - SCROLL_SPACE;

        if (screenSpace >  1959){
            GH.Util.addClassName('gh', 'gh-dyn-over');
            GH.Util.write('js-cardwidth', "");
        }
        else{
            var idx = 1,
                cards = 1,
                summaries = 1;

            var colNumber = AJS.$('div.gh-step-header').size();
            if (screenSpace <= 1130){
                switch(colNumber)
                {
                    case PB:cards = 3; summaries = 4; break;
                    case 1: cards = 3; summaries = 4; break;
                    case 2: cards = 2; summaries = 2; break;
                    case 3: cards = 1; summaries = 2; break;
                    case 4: cards = 1; summaries = 1; break;
                    case 5: cards = DEFAULT; summaries = 1; break;
                    case 6: cards = DEFAULT; summaries = 1; break;
                    default: cards = DEFAULT; summaries = DEFAULT; break;
                }
            }
            else if (screenSpace > 1130 && screenSpace <= 1350){
                idx = 2;
                switch(colNumber)
                {
                    case PB:cards = 4; summaries = 5; break;
                    case 1: cards = 3; summaries = 4; break;
                    case 2: cards = 2; summaries = 3; break;
                    case 3: cards = 1; summaries = 2; break;
                    case 4: cards = 1; summaries = 1; break;
                    case 5: cards = DEFAULT; summaries = 1; break;
                    case 6: cards = DEFAULT; summaries = 1; break;
                    case 7: cards = DEFAULT; summaries = 1; break;
                    default: cards = DEFAULT; summaries = DEFAULT; break;
                }
            }
            else if (screenSpace > 1350 && screenSpace <= 1400){
                idx = 3;
                switch(colNumber)
                {
                    case PB:cards = 4; summaries = 5; break;
                    case 1: cards = 3; summaries = 5; break;
                    case 2: cards = 2; summaries = 3; break;
                    case 3: cards = 1; summaries = 2; break;
                    case 4: cards = 1; summaries = 2; break;
                    case 5: cards = 1; summaries = 1; break;
                    case 6: cards = DEFAULT; summaries = 1; break;
                    case 7: cards = DEFAULT; summaries = 1; break;
                    case 8: cards = DEFAULT; summaries = 1; break;
                    default: cards = DEFAULT; summaries = DEFAULT; break;
                }
            }
            else if (screenSpace > 1400 && screenSpace <= 1530){
                idx = 4;
                switch(colNumber)
                {
                    case PB:cards = 4; summaries = 5; break;
                    case 1: cards = 4; summaries = 5; break;
                    case 2: cards = 2; summaries = 4; break;
                    case 3: cards = 1; summaries = 2; break;
                    case 4: cards = 1; summaries = 2; break;
                    case 5: cards = DEFAULT; summaries = 1; break;
                    case 6: cards = DEFAULT; summaries = 1; break;
                    case 7: cards = DEFAULT; summaries = 1; break;
                    case 8: cards = DEFAULT; summaries = 1; break;                    
                    default: cards = DEFAULT; summaries = DEFAULT; break;
                }
            }
            else if (screenSpace > 1530 && screenSpace <= 1700){
                idx = 5;
                switch(colNumber)
                {
                    case PB:cards = 5; summaries = 6; break;
                    case 1: cards = 5; summaries = 6; break;
                    case 2: cards = 2; summaries = 3; break;
                    case 3: cards = 2; summaries = 3; break;
                    case 4: cards = 1; summaries = 2; break;
                    case 5: cards = 1; summaries = 1; break;
                    case 6: cards = 1; summaries = 1; break;
                    case 7: cards = DEFAULT; summaries = 1; break;
                    case 8: cards = DEFAULT; summaries = 1; break;
                    case 9: cards = DEFAULT; summaries = 1; break;
                    default: cards = DEFAULT; summaries = DEFAULT; break;
                }
            }
            else if (screenSpace > 1700 && screenSpace <= 1959){
                idx = 6;
                switch(colNumber)
                {
                    case PB:cards = 6; summaries = 7; break;
                    case 1: cards = 5; summaries = 7; break;
                    case 2: cards = 3; summaries = 4; break;
                    case 3: cards = 2; summaries = 3; break;
                    case 4: cards = 1; summaries = 2; break;
                    case 5: cards = 1; summaries = 2; break;
                    case 6: cards = 1; summaries = 1; break;
                    case 7: cards = DEFAULT; summaries = 1; break;
                    case 8: cards = DEFAULT; summaries = 1; break;
                    case 9: cards = DEFAULT; summaries = 1; break;
                    case 10: cards = DEFAULT; summaries = 1; break;
                    default: cards = DEFAULT; summaries = DEFAULT; break;
                }
            }

            GH.Util.addClassName('gh', 'gh-dyn-' + idx);
            var cardsPerRow = GH.Util.innerValue('issueDisplay') == 'summary' ? summaries : cards;
            cardsPerRow = cardsPerRow + (GH.Util.hasClassName("gh", "gh-column-hidden") ? 1 : 0);

            var padding = parseInt($('gh-issues').getStyle("padding-right").split("px")[0]) + parseInt($('gh-issues').getStyle("padding-left").split("px")[0]) + (colNumber * TB_COL_PADDING);
            var pbStyle = (Boards.isPlanningBoard() || Boards.is('ProjectBoard')) && cardsPerRow > 0 ? "#gh.gh-board-planning.gh-cards .gh-issue{width:" +  ((screenSpace - padding)/cardsPerRow - PB_ISSUE_PADDING) +"px;}" : "";
            var tbStyle = Boards.is('TaskBoard') && cardsPerRow > 0 ? "#gh.gh-board-task .gh-cards .gh-issue{width:" +  (((screenSpace - padding)/cardsPerRow)/colNumber - TB_ISSUE_PADDING) +"px;}" : "";
            if (Prototype.Browser.IE) {
	            var style = new Element('style', { type: 'text/css' });
	            style.styleSheet.cssText = pbStyle + tbStyle;
	            $('js-cardwidth').update(style);
            } else {
                GH.Util.write('js-cardwidth', "<style type='text/css'>" + pbStyle + tbStyle + "</style>");
            }
        }
    };
	this.changeBoard=function(view){
		Boards.working();
		Boards.submit(view, $H({selectedBoardId:''}));
	};
	this.gotoBoard=function(view){
		Boards.working();
		Boards.submit(view);
	};
	this.changeView=function(boardId){
		Boards.getBoard(boardId).selectBoard();
	};
	this.changeTaskBoard=function(plain){
		Boards.working();
		Boards.submit("SetPlainTaskBoard",$H({plain:plain}));
	};
	this.changeReleased=function(){
		Boards.submit($F('releasedType'));
	};
	this.relocate=function(pId, bId){ 
		Boards.destroy(); 
		window.location = this.ctx+"/secure/"+Boards.type(true)+".jspa?selectedProjectId="+pId+(bId?"&selectedBoardId="+bId:"")+($('configTab')?"&configTab="+$F('configTab'):"");
	};
	this.closeIFrame=function(id, time){
		Boards.updater('confirmation', "CloseIFrame", $H({id: id, displayedTime: time }), true, Boards.success);
	};
	this.viewIssue=function(key, event){
		if (Prototype.Browser.WebKit && event && event.isMiddleClick()) {
			// workaround for bug in WebKit (https://bugs.webkit.org/show_bug.cgi?id=22382)
			return true;
		} else {
			Boards.updater('confirmation', "GetIssue", $H({key:key}), true, Boards.doneWorking);
			return false;
		}
	};
	this.updatePBar=function(){
		Boards.updater('pBar', "UpdatePBar", $H({}), true, Boards.doneWorking);	
	};
	this.editIssue=function(id){
		Boards.updater('confirmation', "GHEditIssue", $H({id:id}), false, Boards.success);		
	};
	// requests a jira action url. Either performs the request inside an iframe or reloads the current window depending on the user preferences
	this.jiraIssueAction=function(id, url){
		if (GH.CONFIG.useJiraIFrame) {
			Boards.updater('confirmation', "GenericIssueIFrame", $H({id:id, url:url, absoluteUrl:true}), false, Boards.success);
		} else {
			window.location.href = url;
		}
	};
	this.newSubTask=function(key, next, push, type){
		var fields = push ? Boards.getFieldValues('new') : [[],[]];
		var forcedFields = Boards.getFieldValues('forced');
		var projectId = $('gh-project') ? $F('gh-project') : '';
		type = type ? type : ($('subType') ? $F('subType') : '');
		Boards.updater('confirmation', "GHAddIssue", $H({key:key, issueType:type, fieldsKeys:fields[0].slice(0,-1), fieldsValues:fields[1].slice(0,-3), forcedFieldsKeys:forcedFields[0].slice(0,-1), forcedFieldsValues:forcedFields[1].slice(0,-3), createNext:next, projectId:projectId}), true, Boards.success);
	};
	this.newIssue=function(next, push, type){
		var fields = push ? Boards.getFieldValues('new') : [[],[]];
		var forcedFields = Boards.getFieldValues('forced');
		type = type ? type : ($('issueType') ? $F('issueType') : '');
		var projectId = $('gh-project') ? $F('gh-project') : '';
		var relativeIssue = push && Ranking.relativeIssue ? Ranking.relativeIssue : Boards.focussedBoard().firstSelection();
		Boards.updater('confirmation', "GHAddIssue", $H({issueType:type, relativeIssueKey:relativeIssue, fieldsKeys:fields[0].slice(0,-1), fieldsValues:fields[1].slice(0,-3), forcedFieldsKeys:forcedFields[0].slice(0,-1), forcedFieldsValues:forcedFields[1].slice(0,-3), createNext:next, projectId:projectId}), true, Boards.success);
	};
	// This is prefilling the form elements with selected values in case the user chooses to change the issue type and reload the dialog
	this.pushValues=function(fields, values, disable){
		$$('*[id^=newField_]').each(function(e){
			var id=e.readAttribute("fieldId");
			if(fields.indexOf(id) >= 0){
                if (id == 'assignee' || id == 'reporter') {
                    var value = Encoder.htmlDecode(values[fields.indexOf(id)]);
                    // add in an option with that value
                    var $field = AJS.$('select[id=newField_'+id+']');
                    $field.empty();
                    var displayValue = value;
                    if (displayValue == '') {
                        displayValue = AJS.I18n.getText('gh.issue.noassignee');
                    } else if (displayValue == '0') {
                        displayValue = AJS.I18n.getText('gh.boards.autoassign');
                    }

                    var descriptor = new AJS.ItemDescriptor({
                        value: value,
                        label: displayValue
                    });

                    var selectObject = $field.data('selectObject');
                    if (selectObject) {
                        selectObject.setSelection(descriptor);
                    }
                }
				else if($(e).nodeName == "SELECT" && $(e).getAttribute("multiple") != null){
					var options = $(e).options;
					var selections = Encoder.htmlDecode(values[fields.indexOf(id)]).split(",");
					for(var i = 0; i < options.length; i++){
						if(selections.indexOf(options[i].value) >= 0){
							options[i].selected='selected';
						}
					}
				}
				else{
					$(e).value = Encoder.htmlDecode(values[fields.indexOf(id)]);
				}
				if(disable){
					$(e).disabled = disable;
					GH.Util.hide('edit_'+id);
				}
			}
		});
	};
	this.createIssue=function(key, next){
		var fields = Boards.getFieldValues('new');
		var forcedFields = Boards.getFieldValues('forced');
		var projectId = $('gh-project') ? $F('gh-project') : "";
		Boards.updater('query-results',"GHCreateNewIssue", $H({key:key, issueType:($('issueType')? $F('issueType') : $F('subType')), fieldsKeys:fields[0].slice(0,-1), fieldsValues:fields[1].slice(0,-3), forcedFieldsKeys:forcedFields[0].slice(0,-1), forcedFieldsValues:forcedFields[1].slice(0,-3), createNext:next, projectId:projectId}), true, Boards.success);
	};
	this.getFieldValues=function(type){
		var fields = ""; var values = "";
		$$('*[id^='+type+'Field_]').each(function(e){
				var id=e.readAttribute("fieldId");
				if(id){
					fields += id +  ",";
					var value = $F(e) && $F(e).constructor === Array ? Boards.getMSValue(e) : $F(e);
					values += (value== '' ? ' ': value) + "@%@";
				}
		});
		//Support labels until the labels picker is in aui
		$$('*[name^='+type+'Field_label_]').each(function(e){
				var id = e.readAttribute("fieldId");
				if(id){
					fields += id +  ",";
					var value = $F(e) && $F(e).constructor === Array ? Boards.getMSValue(e) : "";
					values += (value== '' ? ' ': value) + "@%@";
				}
		});
		return [fields, values];
	};
	this.synch=function(){
		Boards.submit('Synch');
	};
	this.doAction=function(action){
		Boards.updater('confirmation', action, $H({}), true, Boards.doneWorking);
	};
	this.cardUpdated=function(dropId, element, e){
		if(element.id.startsWith("marker_")){
			var above = !GH.Util.isSelectionModifier(e) && !e.shiftKey;
			Boards.updater('confirmation', 'MarkerUpdating', $H({fieldId:element.id.split("marker_")[1], dropBoardId:dropId, selectedBoardId:Boards.focussedBoard().id, above:above}), false, Boards.success);
		}
		else{
			GH.Util.hide(element);
			Boards.updater('confirmation', 'Updating', $H({issueKeys:Boards.draggedIssue.board.selectedIssuesQueryString(), dropBoardId:dropId, selectedBoardId:Boards.draggedIssue.board.id}), true, Boards.doneWorking);
		}
	};
	this.lastDrop=function(element){
		if(Boards.draggedIssue){
			Boards.focussedBoard().getIssueAt(Boards.focussedBoard().issues.size()).cardDropped(element, true);
		}
	};
	this.addSelectedSubs=function(iKeys){
		iKeys = !iKeys ? "" : iKeys+",";
		var subKeys = $$('input[class^="js-subbox"]');
		for (var counter = 0; counter < subKeys.size(); counter++){
			if (subKeys[counter].checked == true){
				iKeys = iKeys + subKeys[counter].value + (counter < subKeys.size() - 1 ? ", " : "");
			}
		}
				
		subKeys=null;
		return iKeys;
	};
	this.allSubs=function(checked){
		var subKeys = $$('input[class^="js-subbox"]');
		for (var counter=0; counter<subKeys.length; counter++)
			if(Element.getHeight(subKeys[counter]) > 0) //hack
				subKeys[counter].checked = checked;
	};
	// updates the status on the task board outline view for parent issues (that have children)
	this.updatingPStatus=function(iKey){
		// Find the issue for this key
		var issue;
		Boards.boards.values().each(function(board){
			issue = board.getIssue(iKey);
			if (issue) {
				throw $break;
			}
		});
		if (issue) {
			// unselect all, then add this issue as selected issue to the board
			// hack: set directly the issue as selected (the parent is not selectable in the outline view)
			Boards.focussedBoard().unselect(true, issue.key);
			issue.board.selectedIssues.set(issue.key, issue);
			Boards.updater('confirmation', "UpdatingStatus", $H({key:issue.key}), false, Boards.success);
		}
	};
	this.updatingStatus=function(newStepId, element){
		if(Boards.draggedIssue.board.id != newStepId){
			GH.Util.hide(element);
			Boards.draggedIssue.updatingStatus(newStepId);
		} else {
			delete Boards.droppedBoard;
		}
	};
	this.refreshSearchStats=function(key, searchType){
		Boards.updater("search-column", "RefreshSearchStats", $H({type:Boards.type(), inSearchMode:true, searchKey:key, searchType:searchType}), true, Boards.success);
	};
	this.retrieve=function(key, searchType, selectedIssueId){
		Boards.searchStart=0;
		Boards.inSearchMode = true;
		if(Boards.isPlanningBoard()){
			Boards.mainBoard.disableDrops();
		}
		else if(Boards.is('TaskBoard')){
			Boards.boards.values().each(function(board){
				board.disableDrop();
			});
		}
		GH.Util.write('confirmation', '');
		var st = $('searchType');
		// this isn't shown if the user is not logged in
		if (st) st.value = searchType;
		Boards.updater("search", "SearchBoard", $H({type:Boards.type(), searchKey:key, start:0, searchType:searchType, id:selectedIssueId}), false, Boards.success);
	};
	this.search=function(id){
		if(GH.Util.trim($F(id))=='') return;
		
		Boards.retrieve($F(id), "query");
		$(id).value =  '';
		$(id).blur();
	};
	this.searchFor=function(start, key, searchType, redirectType){
		Boards.searchStart=start;
		Boards.updater("search-results", "SearchAgain", $H({type:Boards.type(), searchKey:key, start:start, searchType:searchType, redirectType:redirectType}), true, Boards.doneWorking);
	};
	this.resetSearchInput=function(id, force){
		var thing = $(id+'In');
		// can't be bothered to find out what it is we're actually looking at. But if you're not logged in, it's not there.
		if(thing && (force || thing.value == '')){
			thing.value = '';
		}
	};
	this.cleanSearch=function(){
		Boards.inSearchMode = false;
		Boards.removeBoard(10);
		if(Boards.isPlanningBoard()){
			Boards.mainBoard.enableDrops();
		}
		else if(Boards.is('TaskBoard')){
			Boards.boards.values().each(function(board){
				board.enableDrop();
			});
		}
		
		Boards.searchStart = 0;
		Boards.resetSearchInput('search', true);
		GH.Util.write('search', '');
	};
	/** Hides the 'search' div and unattaches the escape listener. Does NOT dispose the search form nor change the inSearchMode flag.
	 */
	this.hideSearchPopup=function(){
		GH.Util.hideAll(['dialog', 'search']);
		Event.stopObserving(document, 'keydown', Boards.searchPopupEscapeHandler);
	};
	/** Shows the search popup and attaches the escape handler. */
	this._showSearchPopup=function(){
		GH.Util.showAll(['dialog', 'search']);
		Event.observe(document, 'keydown', Boards.searchPopupEscapeHandler);
	};
	this.returnToSearch=function(){
		GH.Util.hideAll(['waiting', 'confirmation', 'opt_wait', 'popup_wait', 'search_wait']);
		Boards.closeAJSPopup();
		GH.Util.write('confirmation', '');
		Boards.dimAndMoveDialogElements();
		Boards._showSearchPopup();
	};
	this.mimicSearch=function(id, trigger){
		if($(id).value==trigger){
			$(id).value="";
		}
	};
    /*  Dialogs responding to available space -
    *   If no given sizes specified the popup will maximise */
    this.dynAJSPopup=function(givenWidth,givenHeight){
        var winHeight = AJS.$(window).height(),
            winWidth = AJS.$(window).width(),
            maxHeight = winHeight - 60,
            maxWidth = winWidth - 40,
            dynHeight = givenHeight || maxHeight,
            dynWidth = givenWidth || maxWidth;
        // if clipped resize to fit and allow for padding
        if (givenHeight + 40 > winHeight) {
            dynHeight = maxHeight;
        }
        if (givenWidth + 40 > winWidth) {
            dynWidth = maxWidth;
        }
        // pass the values to the standard dialog function
        this.newAJSPopup(dynWidth, dynHeight);
    };
	this.showAJSPopup=function(page, panel, focus){
		Boards.doneWorking();
		if(Boards.inSearchMode){
			Boards.hideSearchPopup();
		}
		Boards.AJSpopup.gotoPage(page);
		Boards.AJSpopup.gotoPanel(panel);
		Boards.AJSpopup.show();
		
		if(focus){
			Boards.ffocus(focus);	
		}
	};
	this.closePopup=function(){
		Boards.closeAJSPopup();
		if(Boards.inSearchMode){
			Boards.cleanSearch();
		}
		if(Boards.needsRefresh){
			Boards.refreshAll();
		}
		else{
			Boards.doneWorking();
		}
	};
	this.newAJSPopup=function(width, height, options){
		Boards.closeAJSPopup();
		Boards.AJSpopup = new AJS.Dialog(width, height, options);

		// add functions to add a cancel/close action
		Boards.AJSpopup.addCloseAction =
		Boards.AJSpopup.addCancelAction =
		Boards.AJSpopup.addDismissAction = function(actionText, modifierKey){
			this.addCancel(actionText, function(){ Boards.AJSpopup.cancelPopup(); });
			var $cancelLink = AJS.$(Boards.AJSpopup.popup.element).find('.button-panel-cancel-link');
			$cancelLink.attr( {'accessKey' : '`', 'title': actionText + ' (' + modifierKey+'+`)' });
	        if (AJS.$.browser.msie) {
	            $cancelLink.focus(function(e){
	                if (e.altKey){
	                    $cancelLink.click();
	                }
	            });
	        }
		};
		
		// Redirect the dialog cancel (triggered by escape) to our own implementation, cancelPopup
		Boards.AJSpopup.popup.handleCancel = function() {
		  // Ajax requests on Firefox fail if issued through an (escape) key event, IF the key event propagation is not stopped.
		  // As the escape is handled by a hidden function inside popup.js, which then calls handleCancel(), we can't touch
		  // the event and therefore can't fix the issue that way.
			// Workaround: do the actual action after a timeout, which will happen outside the keyboard event.
			if (Boards.AJSpopup && ! Boards.AJSpopup.handleCancelRunning) {
				Boards.AJSpopup.handleCancelRunning = true;
				setTimeout('(function(){if(Boards.AJSpopup){Boards.AJSpopup.cancelPopup();}})()', 0);
			}
		}
		// called by the cancel buttons to cancel the popup
		Boards.AJSpopup.cancelPopup = function() {
			// check whether we have to close the popup
			var doNotClose = Boards.AJSpopup.cancelCallback();
			if (!doNotClose) {
				Boards.closePopup();
			}
			// accept events again if there is still a dialog around
			if (Boards.AJSpopup) {
				Boards.AJSpopup.handleCancelRunning=false;
			}
		}
		// This function can be overridden to do additional dialog cancel work.
		// Return true if you don't want the popup to be closed automatically
		Boards.AJSpopup.cancelCallback = function() {}		
	};
	this.closeAJSPopup=function(){
		if(Boards.AJSpopup){
			Boards.AJSpopup.hide();
			Boards.AJSpopup.remove();
			Boards.AJSpopup = null;
		}
	};
	this.getBoardForIssue=function(iKey, type, commitedIn){
		if(Boards.inSearchMode) Boards.cleanSearch();
		Boards.working();

		Boards.colPagination.currentPage = '0';
		var params = $H({type:type, key:iKey, commitedIn:(commitedIn?commitedIn:false), issueKeys:iKey});
		if(commitedIn)params = params.merge({selectedBoardId:"-1"});
		Boards.submit("GetBoardForIssue", params);
	};
	this.getBoardForIssue2=function(iKey, commitedIn){
		if(Boards.inSearchMode) Boards.cleanSearch();
		Boards.working();

		var params = $H({key:iKey, commitedIn:(commitedIn?commitedIn:false)});
		Boards.submit("GetBoardForIssue2", params);
	};
	this.gotoBoardForIssue2=function(iKey, commitedIn, pageType, subType){
		if(Boards.inSearchMode) Boards.cleanSearch();
		Boards.working();

		var params = $H({key:iKey, commitedIn:commitedIn, pageType:pageType, subType:subType});
		Boards.submit("GetBoardForIssue2", params);
	};
	this.manage=function(){
		Boards.submit("Manage");
	};
	this.addingVersion=function(){
		Boards.updater('confirmation', "ManageVersion",$H({}), true, Boards.doneWorking);
	};
	this.addVersion=function(createNext){
		Boards.updater('query-results', "GHCreateVersion",$H({name:$F('versionName'), masterId:$F('master'), releaseDate:$F('releaseDateIn'), endDate:$F('endDateIn'), date:$F('stratDateIn'), description:$F('versionDesc'), createNext:createNext?true:false}), true, Boards.success);
	};
	this.resetVersionInputs=function(){
		$('versionName').value = $('stratDateIn').value = $('endDateIn').value = $('releaseDateIn').value = $('versionDesc').value='';
		GH.Util.write('query-results', '');
		Boards.ffocus('versionName');
		Boards.doneWorking();
	};
	this.reloadBoard=function(params){
		var params = params ? params : $H();
        Boards.submit(Boards.type(true), params.merge({pageType:'', subType:''}));
	};
	this.enableCtxOpt=function(opt, option){
		var sel = $(opt + "-sel-" + option);
		sel.disabled = false;
		$$("#ctx-" + opt + "-" + option + " [class*=js-options]").each(function(el){
			if(el.checked){
				sel.disabled = true;
				sel.options[0].selected = true;
				for(var i=1; i < sel.options.length; i++){
					sel.options[i].selected = false;
				}
				throw $break;	
			}
		});
	};
	this.setCtx=function(contextId){
		Boards.updater('confirmation', "SetCtx" , $H({contextId:contextId}), true, Boards.success);
	};
	this.checkSortBy=function(){
		if(GH.Util.hasClassName("ctx-sort-" + $F('ctx-sort'), 'js-rank')){
			$('ctx-order-true').checked=true;
			$('ctx-order-true').disabled=true;
			$('ctx-order-false').disabled=true;
		}
		else{
			$('ctx-order-true').disabled=false;
			$('ctx-order-false').disabled=false;
		}
	};
	this.createCtx=function(contextId){
		//This contextId that is passed in is the value of the context that was selectd to edit.
		Boards.updater('confirmation', "CreateCtx", $H({contextId:contextId}), true, Boards.doneWorking);
	};
	this.editCtx=function(contextId){
		Boards.updater('confirmation', "EditCtx", $H({contextId:contextId}), true, Boards.doneWorking);
	};
	this.deleteCtx=function(contextId){
		Boards.updater('query-results', "DeleteCtx", $H({contextId:contextId}), true, Boards.success);
	};
	this.saveCtx=function(){
	    Boards.updater('query-results', "SaveCtx", $H({contextId:$F('ctx-id'), contextName:$F('ctx-name'), sortField:$F('ctx-sort'), sortOrder:($F('ctx-order-true')?'ASC':'DESC'), share:($('ctx-share') ? $('ctx-share').checked : false), jiraFilter:Boards.getMSValue('jira-filter'), statusIds:Boards.getMSValue('status-sel-filter'), assignee:Boards.getMSValue('assign-sel-filter'), personalFilterOn:($F('personal-filter')?true:false), componentIds:Boards.getMSValue('component-filter'), unresolvedFilterOn:($F('unresolved-filter')?true:false), doneFilterOn:($F('done-filter')?true:false), typeIds:Boards.getMSValue('type-filter'), priorityIds:Boards.getMSValue('priority-filter'), jiraHilite:Boards.getMSValue('jira_highlight'), hiliteStatusIds:Boards.getMSValue('status-sel-highlight'), hiliteComponentIds:Boards.getMSValue('component-highlight'), hiliteUnresolvedFilterOn:($F('unresolved-highlight')?true:false), hiliteDoneFilterOn:($F('done-highlight')?true:false), hiliteTypeIds:Boards.getMSValue('type-highlight'), hilitePriorityIds:Boards.getMSValue('priority-highlight'), hiliteAssignee:Boards.getMSValue('assign-sel-highlight')}), true, Boards.success);
	};
	//saveCtx2 takes into account new ids of the new implementation and additional fields.
	this.saveCtx2=function(){
	    Boards.updater(
	    	'query-results', 
	    	"SaveCtx", 
	    	$H({
				contextId:$F('ctx-id'), 
				contextName:$F('ctx-name'), 
				sortField:$F('ctx-sort'), 
				sortAsc:($F('ctx-order-true') ? true : false), 
				shared:($('ctx-share') ? $('ctx-share').checked : false), 
				filterJira:Boards.getMSValue('jira-FILTER'), 
				filterStatus:Boards.getMSValue('status-sel-FILTER'), 
				filterUnresolvedFilterOn:($F('unresolved-FILTER') ? true : false), 
				filterDoneFilterOn:($F('done-FILTER') ? true : false), 
				filterAssignees:Boards.getMSValue('assign-sel-FILTER'), 
				filterPersonalFilterOn:($F('personal-FILTER') ? true : false), 
				filterComponents:Boards.getMSValue('component-FILTER'), 
				filterTypes:Boards.getMSValue('type-FILTER'), 
				filterPriorities:Boards.getMSValue('priority-FILTER'), 
				highlightJira:Boards.getMSValue('jira-HIGHLIGHT'), 
				highlightStatus:Boards.getMSValue('status-sel-HIGHLIGHT'), 
				highlightUnresolvedFilterOn:($F('unresolved-HIGHLIGHT') ? true : false), 
				highlightDoneFilterOn:($F('done-HIGHLIGHT') ? true : false), 
				highlightAssignees:Boards.getMSValue('assign-sel-HIGHLIGHT'), 
				highlightPersonalFilterOn:($F('personal-HIGHLIGHT') ? true : false), 
				highlightComponents:Boards.getMSValue('component-HIGHLIGHT'), 
				highlightTypes:Boards.getMSValue('type-HIGHLIGHT'), 
				highlightPriorities:Boards.getMSValue('priority-HIGHLIGHT')
	    	}),
	    	true,
	    	Boards.success
	    );
	};
	this.findIssue=function(cardId){
		return Boards.getBoard(cardId.split("_")[1]).findIssue(cardId);
	};
	this.focussedBoard=function(){
		return Boards.inSearchMode ? this.boards.get(10) : Boards.mainBoard;
	};
	this.firstSelectedIssue=function(){
		var res;
		// if a search board is displayed then reduce the search to the search board
		if (Boards.inSearchMode) {
			// search board ID is always 10
			var SEARCH_BOARD_ID = 10;
			var searchBoard = Boards.getBoard(SEARCH_BOARD_ID);
			if (searchBoard) {
				var issueKey = searchBoard.firstSelection();
				if(issueKey){
					res = searchBoard.getIssue(issueKey);
				}
			}
		} else {
			Boards.boards.values().each(function(board){
				var issueKey = board.firstSelection();
				if(issueKey){
					res = board.getIssue(issueKey);
					throw $break;
				}
			});
		}
		return res;
	};
	// searches an issue on all boards and returns the first one matching issueKey
	this.searchIssue=function(issueKey) {
		var res;
		Boards.boards.values().each(function(board){
			var issue = board.getIssue(issueKey);
			if (issue) {
				res = issue;
				throw $break;
			}
		});
		return res;
	};
	this.quickFilterUpdate=function(filter,id){
		Boards.updater("confirmation", "Toggle" + filter, $H({}), true, Boards.refreshMain);
		Boards.callCount--;
        AJS.$('#'+id).toggleClass('active');
	};
	this.refreshAll=function(){
		if(!Boards.is('TaskBoard')){
		    // the project name can be changed in the box
			if(Boards.is('ProjectBoard')){
				Boards.refreshProjectcrumbs();
			}
			Boards.mainBoard.refreshBreadcrumbs();
			Boards.mainBoard.refreshMainBoard();
			Boards.refreshColumn();
		}
		else{
			Boards.reloadBoard();
		}
	};
	this.refreshProjectcrumbs=function(){
		Boards.updater('gh-projectcrumbs', 'GHRefreshProjectcrumbs', $H({}), true, Boards.doneWorking);
	};
	this.refreshModBar=function(){
		Boards.updater('gh-mod-bar', Boards.type() + 'RefreshModBar', $H({}), true, Boards.doneWorking);
	};
	this.refreshMain=function(){
		Boards.mainBoard.refreshMainBoard();
	};
	this.refreshColumn=function(page){
		Boards.boards.values().each(function(board){
			if(!board.isMain()){
				Boards.removeBoard(board.id);
			}
		});
		this.updater('gh_column_contents', 'RefreshColumn', $H({colPage: (page ? page : Boards.colPagination.currentPage)}), true, Boards.doneWorking);
	};
	this.inavigator=function(id, navInfo){
		if(Boards.inSearchMode){
			Boards.submit("SBIssueNavigator",$H({searchKey:$F('searchKey'), searchType:$F('searchType'), navInfo:(navInfo?navInfo:"")}));
		}
		else{
			Boards.submit((Boards.is('TaskBoard')?"TB":"PB")+"IssueNavigator",$H({dropBoardId:id, stepId:id, navInfo:(navInfo?navInfo:"")}));
		}
	};
	this.addCharCounter=function(id, limit, forCreate){
		var inId = forCreate ? id : id;
		var cntId = forCreate ? "charCnt_"+id : "charCnt_"+id;
		Event.observe(inId, 'keydown', GH.Util.charCounter.bindAsEventListener(this, inId, limit, cntId));
		Event.observe(inId, 'keyup', GH.Util.charCounter.bindAsEventListener(this, inId, limit, cntId));
		GH.Util.write(cntId, (limit-$F(inId).length));
	};
	this.setIssueDisplay=function(issueDisplay){
		Boards.mainBoard.setIssueDisplay(issueDisplay);
	};
	this.setIssueDisplay2=function(issueDisplay){
		Boards.mainBoard.setIssueDisplay2(issueDisplay);
	};
	this.toggleScreen=function(){
		if($('Screen_chk').className=='js-off'){
			GH.Util.addClassName(document.body, "gh-fullscreen");
			//GH.Util.hideAll(['header', 'studio-header']);
			GH.Util.setClassName('Screen_chk', 'gh-icon gh-icon-tick js-on');
			Boards.request("FullScreen");
		}
		else
		{
			GH.Util.removeClassName(document.body, "gh-fullscreen");
			//GH.Util.showAll(['header', 'studio-header']);
			GH.Util.setClassName('Screen_chk', 'js-off');
			Boards.request("NormalScreen");
		}
	};
	this.toggleLegend=function(setting){
		if(!GH.Util.isVisible("gh-legend")){
			GH.Util.setClassName('Legend_chk', 'gh-icon gh-icon-tick js-on');
			Boards.updater("gh-legend", "GetLegend", $H({}), true, Boards.doneWorking);
		}
		else
		{
			GH.Util.hide("gh-legend");
			GH.Util.setClassName('Legend_chk', 'js-off');
			Boards.request("CloseLegend");
		}
	};
	this.getPref=function(){
		Boards.updater("confirmation", "GetUserPreferences", $H({}), true, Board.doneWorking);
	};
	this.savePref=function(){
		var params = $H({opacityRatio:$F('oRatio'),listAlt:($('listAlt') && $F('listAlt')?true:false),cardBgColored:($('cardBgColored') && $F('cardBgColored')?true:false)});
		params = params.merge({maxVBIssues:$F('maxVBIssues')});
		params = params.merge({maxTBIssues:$F('maxTBIssues'),autoAssignOn:($('autoAssign')&&$F('autoAssign')?true:false),maxParents:($('maxParents')?$F('maxParents'):0)});
		params = params.merge({withDates:($F('withDates')?true:false),withForecast:($F('withForecast')?true:false),withLabels:($F('withLabels')?true:false),precision:$F('precision')});
		Boards.updater("query-results", "SaveUserPreferences", params, true, Boards.doneWorking);
	};
	this.closePopups=function(){
		// Don't use class selectors, as this is really slow on IE
		//$$('[class*=closable]').each(function(element){GH.Util.hide(element);});
		GH.Util.hide('gh-notification');
		// close all issue menus
		Boards.boards.values().each(function(board){
			board.issues.values().each(function(issue){
				issue.closeMenu();
			});
		});
	};
	this.hideSpinner=function(){
		GH.Util.hide('waiting_display');
	};
	this.editLabel=function(formName, elId)
	{
	    var url = Boards.ctx+'/secure/popups/IssuePicker.jspa?';
	    url += 'formName=' + formName + '&';
	    url += 'linkFieldName=' + elId + '&';
	    url += 'currentIssue=false&';
	    url += 'singleSelectOnly=true&';
	    url += 'showSubTasks=false&';
	    url += 'showSubTasksParent=true&';
	    url += 'selectedProjectId=' + Boards.selectedProjectId;
	
	    Boards.winPicker =  GH.Util.openWindow(url, 'IssueSelectorPopup', 'status=no,resizable=yes,top=100,left=200,width=520,height=600,scrollbars=yes,resizable');
	    Boards.winPicker.opener = self;
	    Boards.winPicker.focus();
	};
	this.editCFU=function(id, picker, multi){
		GH.Util.switchView('cfEdit_'+ id, 'cfTxt_'+ id);
		Boards.winPicker = GH.Util.openWindow(Boards.ctx+'/secure/popups/'+picker+'Browser.jspa?formName=form_' + id + (multi ? '&multiSelect=true' : '') + '&element=newField_CFSimpleIn_' + id, picker);
		Boards.winPicker.opener = self;
		Boards.winPicker.focus();
	};
	this.getMSValue=function(id){
		var value='';
		var values = $F(id);
		for(var i = 0; i < values.length; i++){ 
			value= value + values[i] + ',';	
		}
		return values.length > 0 ? value.substring(0, value.length-1) : value;
	};
	this.expandAllBoards=function(){
		var boardIds = "";
		Boards.boards.values().each(function(board){
			if(!board.isExpanded()){
				boardIds = boardIds + board.id + ",";
				GH.Util.removeClassName(board.boxId, 'hidden');
			}
		});
		if(boardIds != ""){
			Boards.request("ToggleBox", $H({dropBoardIds:boardIds.substring(0, boardIds.length - 1)}));
		}
	};
	this.colapseAllBoards=function(){
		var boardIds = "";
		Boards.boards.values().each(function(board){
			if(board.isExpanded()){
				boardIds = boardIds + board.id + ",";
				GH.Util.addClassName(board.boxId, 'hidden');
			}
		});
		if(boardIds != ""){
			Boards.request("ToggleBox", $H({dropBoardIds:boardIds.substring(0, boardIds.length - 1)}));
		}
	};
    this.toggleColumn=function(){
		if(GH.Util.hasClassName('gh', 'gh-column-hidden')){
			GH.Util.removeClassName('gh', 'gh-column-hidden');
		}
		else{
			GH.Util.addClassName('gh', 'gh-column-hidden');
		}
        Boards.screenSizeHandler();  
		Boards.request("ToggleBox", $H({dropBoardIds:'col'}));
	};	
	this.doClick=function(functionToExecute){	
		Boards.clickCount++;
        setTimeout(function(){
			if(Boards.clickCount%2 == 1){
				Boards.clickCount = 0;
				functionToExecute();
			}
        }, 250);	
		return true;
    };
	this.getIssueAt=function(issues, index){
		var res;
		issues.each(function(issue){
			if(issue.index == index){
				res = issue;
				throw $break;	
			}
		});
		
		return res;
	};
	this.batchUpdate=function(fromId, toId, keys){
		Boards.updater('confirmation', 'Update', $H({issueKeys:Boards.addSelectedSubs(keys), dropBoardId:toId, selectedBoardId:fromId}), true, Boards.doneWorking);
	};
	this.working=function(){
		Boards.closeAJSPopup();
		Boards.hideSearchPopup();
		GH.Util.hideAll(['confirmation']);
		Boards.dimAndMoveDialogElements();
		GH.Util.showAll(['dialog', 'waiting_display', 'opt_wait', 'popup_wait', 'search_wait']);
	};
	this.doneWorking=function(){
		Boards.success();
		if(Boards.inSearchMode) {
			GH.Util.hideAll(['waiting_display']);
			Boards._showSearchPopup();
		}
		else{
			GH.Util.write('confirmation', '');
			// we only want to undim when there is no dialog displayed
			setTimeout("(function(){GH.Util.hideAll(['dialog']); if(!Boards.AJSpopup){AJS.undim();}})()", 200);
		}
		if(Boards.callCount < 1){
			Boards.callCount = 0;
			GH.Util.hideAll(['opt_wait', 'popup_wait', 'search_wait']);
		}
	};
	this.success=function(){
		Boards.callCount--;
	};
	this.request=function(jspa, params){
		params = params ? params : $H({});
		if(params.get('pageType') == null) params = params.merge({pageType:Boards.pageType});
		if(params.get('subType') == null) params = params.merge({subType:Boards.subType});
		if(params.get('pageType') == '') params.unset('pageType');
		if(params.get('subType') == '') params.unset('subType');
		params = params.merge({decorator:'none', selectedProjectId:Boards.selectedProjectId, type:Boards.type()});
		new Ajax.Request(Boards.ctx+"/secure/"+jspa+".jspa", {method:'post', parameters:params.toQueryString()});
	};
	this.updater=function(id, jspa, params, silent, successCallback){
		Boards.callCount++;
		params = params ? params : $H({});
		params = params.merge({decorator:'none', selectedProjectId:Boards.selectedProjectId});
		if(params.get('pageType') == null) params = params.merge({pageType:Boards.pageType});
		if(params.get('subType') == null) params = params.merge({subType:Boards.subType});
		if(params.get('pageType') == '') params.unset('pageType');
		if(params.get('subType') == '') params.unset('subType');
		if(params.get('type') == null)params = params.merge({type:Boards.type()});
		if(params.get('selectedBoardId') == null) params = params.merge({ selectedBoardId: Boards.mainBoard.id });
		if(!Boards.is('TaskBoard') && params.get('colPage') == null)params = params.merge({colPage:Boards.colPagination.currentPage});
		if(Boards.inSearchMode && params.get('searchKey') == null){
			params = params.merge({inSearchMode:true, searchKey:$F('searchKey'), searchType:$F('searchType')});
		}
		if(!silent){
			Boards.closePopups();
			Boards.working();
		}
		else{
			GH.Util.showAll(['opt_wait', 'popup_wait', 'search_wait']);		
		}
		new Ajax.Updater(id, Boards.ctx+"/secure/"+jspa+".jspa", {method:'post', parameters:params.toQueryString(), evalScripts:true, onSuccess:function(response){ if(successCallback) successCallback.call(this, response); }});
	};
	this.submit=function(jspa, params, anchor){
		params = params ? params : $H({});
		if(params.get('pageType') == null) params = params.merge({pageType:Boards.pageType});
		if(params.get('subType') == null) params = params.merge({subType:Boards.subType});
		if(params.get('pageType') == '') params.unset('pageType');
		if(params.get('subType') == '') params.unset('subType');
		if(params.get('type') == null)params = params.merge({type:Boards.type()});
		if(params.get('selectedProjectId') == null)params = params.merge({selectedProjectId:Boards.selectedProjectId});
		if(params.get('selectedBoardId') == null)params = params.merge({selectedBoardId:Boards.mainBoard.id});
		if(Boards.is('TaskBoard') && params.get('start') == null)params = params.merge({start:Boards.mainBoard.getStart()});
		if(!Boards.is('TaskBoard') && params.get('colPage') == null)params = params.merge({colPage:Boards.colPagination.currentPage});
		if($('configTab') && params.get('configTab') == null)params = params.merge({configTab:$F('configTab')});
		GH.Util.showAll(['opt_wait', 'popup_wait', 'search_wait']);	
		
		document.forms['GHForm'].action=Boards.ctx+"/secure/"+jspa+".jspa?"+params.toQueryString() + (anchor ? "#" + anchor : "");
		Boards.destroy(); 
		
		document.forms['GHForm'].submit();
	};
	this.fillMissingParams=function(params){
        params = params ? params : {};
        if(!params.decorator) params.decorator = 'none';
        if(!params.selectedProjectId) params.selectedProjectid = Boards.selectedProjectId;
        if(!params.pageType) params.pageType = Boards.pageType;
        if(!params.subType) params.subType = Boards.subType;
        if(params.pageType == '') delete params.pageType;
        if(params.subType == '') delete params.subType;
        if(!params.type) params.type = Boards.type();
        if(!params.selectedBoardId) params.selectedBoardId = Boards.mainBoard.id;
        if(!Boards.is('TaskBoard') && ! params.colPage) params.colPage = Boards.colPagination.currentPage;
        if(Boards.inSearchMode && !params.searchKey) {
            params.inSearchMode = true;
            params.searchKey = $F('searchKey');
            params.searchType = $F('searchType');
        }
    };
	this.createDialogElements=function(){
		var dlg = document.createElement('div');
		dlg.id = "dialog";
		dlg.style.display='none';
		dlg.innerHTML="<div id=waiting_display>&nbsp;</div><div id=confirmation align=center style='display:none;'></div><div id=search align=center style='display:none;'></div>";
		AJS.$(document.body).prepend(dlg);
	}
	this.dimAndMoveDialogElements=function(){
		AJS.dim();
		// currently moving the dialog to the end will result in it not being displayed at all
		//AJS.$(AJS.dim.dim).after(AJS.$('#dialog'));
	};
	this.resetMarkers=function(){
		Boards.markers.each(function(pair){
			Boards.markers.unset(pair.key).clean();
		});
	};
	this.destroy=function(){
		Boards.resetMarkers();
		Boards.colPagination.clean();
		// GHS-3117: TODO: Not even sure whether we need this! Cant find a span with given class
		/*New: AJS.$('span.js-page-drop').each(function(index, page) {
			page.droppable('destroy');
		});*/
		/*Old: $$('span[class^="js-page-drop"] span').each(function(page){
            Droppables.remove(page);
        });*/
		Boards.boards.keys().each(function(boardId){Boards.removeBoard(boardId);});
		delete Boards.colPagination;
		delete Boards.markers;
		delete Boards.cookies;
		delete Boards.boards;
	};
	this.type=function(complete, ignoreSearchMode){
		if(Boards.inSearchMode && !ignoreSearchMode) return (complete?'SearchBoard':'SB');
		else if(Boards.is('VersionBoard')) return (complete?'VersionBoard':'VB');
		else if(Boards.is('ProjectBoard')) return (complete?'ProjectBoard':'PB');
		else if(Boards.is('ComponentBoard')) return (complete?'ComponentBoard':'CB');
		else if(Boards.is('AssigneeBoard')) return (complete?'AssigneeBoard':'AB');
		else if(Boards.is('TaskBoard')) return (complete?'TaskBoard':'TB');
		else if(Boards.is('ChartBoard')) return (complete?'ChartBoard':'CCB');
		else if(Boards.is('ArchiveChartBoard')) return (complete?'ArchiveChartBoard':'ACB');
		else if(Boards.is('BacklogBoard')) return (complete?'BacklogBoard':'');
		else return (complete?'Configuration':'');
	};
	this.initPageStyle=function(fullScreen, optColour, advList){
		if(fullScreen) GH.Util.addClassName(document.body, "gh-fullscreen"); //GH.Util.hideAll(['header', 'studio-header']);
		GH.Util.addClassName(document.body, "nl"); // for a few JIRA styles outside of \#gh
        if(optColour) GH.Util.addClassName(document.body, "gh-opt-rainbow");
        if(advList) GH.Util.addClassName(document.body, "gh-opt-list-alt");
	};
	this.registerPageEvents=function(){
	    Event.observe(document.body, 'mouseup', Boards.closePopups);
	    if(Boards.isPlanningBoard()){
	    	Event.observe(document, 'keydown', Boards.markerDownHandler);
	    	Event.observe(document, 'keyup', Boards.markerUpHandler);
	    }
        if(!Boards.is('ConfigurationBoard')){
        	Event.observe(document, 'keydown', Boards.escapeHandler); 
        	Event.observe(window, 'resize', Boards.screenSizeHandler);
        }
	};
	this.selectPreviousBox=function(){
		this.selectBox(-1);
	};
	this.selectNextBox=function(){
		this.selectBox(+1);
	};
	this.selectBox=function(delta){
		if (!Boards.isPlanningBoard() || Boards.inSearchMode) return;
		
		var ids = Boards.getBoxIds();
		var selectedId = Boards.getSelectedBoxId();
		var id = ids[ids.indexOf(selectedId) + delta];
		if (id) {
			Boards.changeView(id);
		}
	};
	this.toggleSelectedBox=function(){
		if (!Boards.isPlanningBoard() || Boards.inSearchMode) return;
		
		var selectedId = Boards.getSelectedBoxId();
		if(selectedId){
			Boards.getBoard(selectedId).toggle();
		}
	};
	this.getBoxIds=function(){
		var ids = $A();
		AJS.$('#gh_column_contents .js-box').each(function(index, element) {
			ids.push(AJS.$(element).attr('id').substring('drop_'.length)); // extract the id from the element
		});
		return ids;
	};
	this.getSelectedBoxId=function(){
		var id;
		AJS.$('#gh_column_contents .js-box').each(function(index, element) {
			if (GH.Util.hasClassName(element, 'gh-selected')) {
				id=AJS.$(element).attr('id').substring('drop_'.length);
			}
		});
		return id;
	};
	this.clearTextSelections=function(){
		var clearSelection = function() {
    	  if(document.selection && document.selection.empty) {
        		document.selection.empty();
        	} else if(window.getSelection) {
            	var selection = window.getSelection();
            	selection.removeAllRanges();
        	}
        };
        // unselect needs to happen after the click event, so we defer
        setTimeout(clearSelection, 0);
    };
	this.refreshStepBoardsForTransition = function(issue) {
		issue.board.refreshStepBoard();
		var target = Boards.droppedBoard;
		
		var doneFunction = function() {
			Boards.doneWorking();
			// show message from local session store
			GH.Message.showIssueMessage(issue.id);
		};
        // GHS-3117 TODO
        //NEW? AJS.$('#gh-step-outer_'+target.id).children().droppable('destroy');
		Boards.updater('gh-step-outer_'+target.id, "RefreshStep", $H({id:issue.id, stepId:target.id, stepStart:target.getStart()}), true, doneFunction); 
		Boards.updater('gh-step-head', 'RefreshHeader', $H(), true, Boards.doneWorking);
		Boards.updatePBar();
		
		// clear out the dropped board
		delete Boards.droppedBoard;
	};

	/*
	 *  Keyboard actions - moved here to keep most code out of atlassian-pluigin.xml
	 */
	this.createNewIssue=function(){
		// check whether we have a create card button
		var $ghCreateButton = AJS.$('#newOptions');
		if ($ghCreateButton.length > 0) {
			Boards.newIssue(false);
		} else {
			var $jiraCreateButton = AJS.$('#create_link');
			if ($jiraCreateButton.length > 0) {
				// copied from whenitype.js moveToAndClick
				$jiraCreateButton.click();
				$jiraCreateButton.scrollIntoView();
			}
		}
	};
	this.focusBoardSearchImpl=function() {
		// depending whether we are in search mode or not we have to select one or the other text box
		var $elem;
		if (Boards.inSearchMode) {
			$elem = AJS.$('#searchModalIn');
		} else {
			$elem = AJS.$('#searchIn');
		}
		// copied from whenitype.js moveToAndFocus
		if ($elem.length > 0) {
			$elem.focus();
            $elem.scrollIntoView();
            /*if ($elem.is(':input')) {
                e.preventDefault();
            }*/
		}
	};
	this.focusBoardSearch=function(){
		// well, well, the key event is passed to the text box if we do the focus synchronously
		setTimeout('Boards.focusBoardSearchImpl();', 0);
	};
	this.assignSelectedIssue=function(){
		var issue = Boards.firstSelectedIssue();
		if (issue) {
			issue.board.unselect(true, issue.key);
			AJS.$('a.issueaction-assign-issue').trigger('click');
		}
	};
	this.commentSelectedIssue=function(){
		var issue = Boards.firstSelectedIssue();
		if (issue) {
			issue.board.unselect(true, issue.key);
			AJS.$('a.issueaction-comment-issue').trigger('click');
		}
	};
	this.editSelectedIssue=function(){
		var issue = Boards.firstSelectedIssue();
		if (issue) {
			issue.board.unselect(true, issue.key);
			if (GH.CONFIG.useJiraIFrame) {
				Boards.editIssue(issue.id);
			} else {
				var url = Boards.ctx+'/secure/EditIssue!default.jspa?id='+issue.id;
				window.location.href = url;
			}
		}
	};
	this.viewSelectedIssue=function(){
		var issue = Boards.firstSelectedIssue();
        if (issue){
        	issue.board.unselect(true, issue.key);
        	if (GH.CONFIG.useJiraIFrame) {
        		Boards.viewIssue(issue.key);
			} else {
				var url = Boards.ctx+'/browse/'+issue.key;
				window.location.href = url;
			}
            
        }
	};
	this.deleteSelectedIssue=function(){
		var issue = Boards.firstSelectedIssue();
		if (issue) {
			issue.board.unselect(true, issue.key);
			AJS.$('a.issueaction-delete-issue').trigger('click');
		}
	};
	this.editSelectedIssueLabels=function(linkId){
		var issue = Boards.firstSelectedIssue();
		if (issue) {
			issue.board.unselect(true, issue.key);
			if (linkId) {
				AJS.$(linkId).trigger('click')
			} else {
				AJS.$('a.issueaction-edit-labels').trigger('click');
			}
        }
	};
	this.editSelectedIssuePriority=function(){
		var issue = Boards.firstSelectedIssue();
		if (issue) {
			issue.board.unselect(true, issue.key);
            issue.updatingPriority();
        }
	};
	this.toggleSelectedCard=function(){
		if (! Boards.isListView()) return;
		
		var issue = Boards.firstSelectedIssue();
        if (issue){
        	issue.board.unselect(true, issue.key);
        	issue.toggle();
        }
	};
	this.showActionsDialog=function(){
		var issue = Boards.firstSelectedIssue();
		if (issue) {
			issue.board.unselect(true, issue.key);
			JIRA.Dialogs.issueActions.show();
		}
	};
	this.selectNextIssue=function(doPageChange){
		var board = Boards.focussedBoard();
		if (board) {
			board.selectNextIssue(doPageChange);
		}
	};
	this.selectPreviousIssue=function(doPageChange){
		var board = Boards.focussedBoard();
		if (board) {
			board.selectPreviousIssue(doPageChange);
		}
	};
};
var Page = Class.create();
Page.prototype = 
{
	initialize:function(id){
		this.id = id;
		this.issues = $H();
		this.selectedIssues = $H(); // should remain empty - Hack to mimic a board
		this.start = -1;
		this.pageLocked = false;
		this.paginationId = this.containerId = 'Page_' + this.id;
		this.idxCorr;
	},
	addIssue:function(start, index, id, key, dropEnabled, parentKey){
		if(this.start != start || !dropEnabled) return;
		var issue = this.issues.set(key, new Issue(index + this.idxCorr, id, key, this, false, true, 'window', false, parentKey));
		if(dropEnabled){
			issue.enableDrop();
		}
		return issue;
	},
	load:function(start, dropEnabled){
		this.pageLocked = true;
		if(this.start != start || dropEnabled){
			this.clean();
			this.start = start;
			var container = $(this.containerId) ? $(this.containerId) : $(this.paginationId);
			if(container){
				container.id = this.paginationId +  "-c-" + start;
				this.containerId = container.id;
				
				this.idxCorr = start > Boards.getBoard(this.id).getStart() ? 10000 : -10000;
				$$("#gh-pagines span[class*=gh-pointer]").each(function(arrow){GH.Util.addClassName(arrow, 'hidden');});
				GH.Util.hide(container);
				
				GH.Util.write(container, '');
				Boards.updater(container.id, "Get" + (Boards.is('TaskBoard')?"TB":"PB") + "Page", $H({start:this.start, stepId:this.id, dropEnabled:dropEnabled}), true, Boards.success);
			}
		}
		else if($(this.paginationId + "-" + this.start + '-dd')){
			this.show(start);
		}
	},
	show:function(start){
		GH.Util.hide('opt_wait');
		var container = $(this.containerId);
		var page = $(this.paginationId + "-" + this.start + '-dd');
		if(!container || !page || GH.Util.isVisible(container)) return;

		container.show();
		var shadow = $(this.paginationId + "-" + this.start + '-dd-s');
		$$("#Page_" + this.id + "-" + this.start  + " span[class*=gh-pointer]").each(function(arrow){GH.Util.removeClassName(arrow, 'hidden');});
		if(!GH.Util.hasClassName(shadow, "gh-shadow")){
			var height = page.getHeight() + Boards.ISSUE_PADDING;
	    	page.setStyle({'height': height + 'px'});
	    	shadow.setStyle({'top':'0px', 'left':'-8px', 'width':(page.getWidth() + 16)+'px', 'height':(height + 14)+'px'});
	    	shadow.innerHTML='<div class="tl"></div><div class="tr"></div><div class="l" style="height:'+(height - 8)+'px;"></div><div class="r" style="height:'+(height - 8)+'px;"></div><div class="bl"></div><div class="br"></div><div class="b" style="width:'+(page.getWidth()-12)+'px;"></div>';
	    	GH.Util.setClassName(shadow, "gh-shadow");
	    	GH.Util.addClassName(this.paginationId + "-" + this.start, "gh-drop-hover");
	    	
			if(this.issues.size() > 0){
			    // GHS-3117:
				// OLD: Droppables.add(page.id, { accept: ['js-mkr', 'gh-issue-wrapper'], triggerIn: function(element){return;}, triggerOut: function(element){return;}, hoverclass:'js-rank-page'});
                AJS.$('#'+page.id).droppable({
                    tolerance: 'pointer',
                    accept: (".js-mkr,.gh-issue-wrapper"),
                    hoverClass: 'js-rank-page'
                });
				Boards.getBoard(this.id).disableDrops();
			}
		}
		
		this.autoHidePage(start);
	},
	autoHidePage:function(start){
		if(this.start == start){
			if(this.isLocked()){
				setTimeout("Boards.getBoard(\'" + this.id + "\').page.autoHidePage(" + start + ");", 500);
			}
			else{
				this.hide();
			}	
		}
	},
	hide:function(){
		var container = $(this.containerId);
		if(!container || !GH.Util.isVisible(container)) return;
		$$("#Page_" + this.id + "-" + this.start  + " span[class*=gh-pointer]").each(function(arrow){GH.Util.addClassName(arrow, 'hidden');});
		container.hide();
		this.clean();
	},
	notifyPage:function(lock){
		this.pageLocked = lock;
	},
	isLocked:function(){
		return this.pageLocked || GH.Util.hasClassName(this.paginationId + "-" + this.start + '-dd', "js-page") || GH.Util.hasClassName(this.paginationId + "-" + this.start + '-dd', "js-rank-page");
	},
	getIssue:function(key){
		return this.issues.get(key);
	},
	getIssueAt:function(index){
		return Boards.getIssueAt(this.issues.values(), index);
	},
	findIssue:function(cardId){
		return this.getIssue(cardId.split("_")[2]);
	},
	getStart:function(){
		return this.start;
	},
	cardDropped:function(element){
		/*
		 TODO http://gdog.sydney.atlassian.com/browse/GH-1212
		if(!GH.Util.hasClassName(element, 'js-mkr')){
			this.hide();
			var board = Boards.getBoard(this.id);
			Boards.updater('confirmation', 'Rank', $H({issueKeys:board.selectedIssuesQueryString(), pageRankStart:this.start, start:board.getStart()}), true, Boards.doneWorking);
		}
		*/
	},
	clean:function(){
		if(this.start > -1){
			// GHS-3117: TODO: retain start a few lines down start is reset to -1
            // by changing this.start below, we're not destroying the correct droppable so gotta store this value
            var oldStart = this.start;
	    	GH.Util.removeClassName(this.paginationId + "-" + this.start, "gh-drop-hover");
			if(this.issues.size() > 0){
				this.start = -1;
				Boards.getBoard(this.id).enableDrops();
				
				var thisIssues = this.issues;
				this.issues.each(function(pair){
					thisIssues.unset(pair.key).clear();
				});
			}
			
			//OLD: Droppables.remove($(this.paginationId + "-" + this.start + '-dd'));
            AJS.$('#'+this.paginationId + '-' + oldStart + '-dd').droppable('destroy');
		}
	}
};
var Marker = Class.create();
Marker.prototype = 
{
	initialize:function(id){
		this.id = id;
		this.mId = "marker_" + id;
		this.enableDrag();
	},
	enableDrag:function(){
		if($(this.mId)){
			var thiz = this; 
			// GHS-3117:
			// OLD: new Draggable(thiz.mId, {onStart: function(element, event){thiz.onStart(event);}, onEnd: function(){thiz.onEnd();}, scroll: window, ghosting: false, revert: true, reverteffect: function(element){$(element).setStyle({'left': '0px', 'top':'0px'});}});
            AJS.$('#'+thiz.mId).draggable({
                revert: true,
                revertDuration: 0,
                zIndex: 3000,
                opacity: 0.7,
                refreshPositions: true,
                start: function(event, ui) {
                    thiz.onStart(event);
                },
                stop: function(event, ui) {
                    thiz.onEnd();
                }
            });
        }
	},
	toggle:function(){
		GH.Util.show('Stats_wait');
		Boards.updater("statistics-table", "ToggleMarker", $H({fieldId:this.id}), true, Boards.doneWorking);
	},
	jumpTo:function(board){
		Boards.updater('confirmation', "Goto" + Boards.type() + "Marker", $H({dropBoardId:board.id, fieldId:this.id, start:board.getStart()}), true, Boards.doneWorking);
	},
	set:function(board, value){
		Boards.updater('confirmation', "SetMarker", $H({fieldId:this.id, start:board.getStart(), markerValue:(value?value:$F(this.mId + "In"))}), true, Boards.doneWorking);
	},
	move:function(board, position, value, txt, setCapacityLink){
		if(position != 'EoL' && !board.issues.get(position)){
			if(board.isMain()){
				board.refreshMainBoard(position);
			}
			else{
				board.selectBoard(position);
			}
		}
		else{
			GH.Util.show(this.mId);
			if(position == 'EoL'){
				$("center-panel").appendChild($(this.mId));
			}
			else{
				$("center-panel").insertBefore($(this.mId), $(board.issues.get(position).cKey));
			}
			$(this.mId).setAttribute('position', position);
			$(this.mId + "In").value = value;
			GH.Util.write(this.mId + "Txt", txt);
			
			if(setCapacityLink){
		        GH.Util.removeClassName(this.mId + "Lbl", 'gh-marker-capacity-set');
			}
			else{
		        GH.Util.addClassName(this.mId + "Lbl", 'gh-marker-capacity-set');
			}
		}
	},
	forcePosition:function(issue){
		var start = '';
		if(this.board instanceof Page){
			start = issue.board.getStart();
			this.board.hide();
		}
		GH.Util.hide(this.mId);
		Boards.updater('confirmation', "EvaluateMarker", $H({fieldId:this.id, start:Boards.mainBoard.getStart(), pageRankStart:start, markerValue:issue.key}), true, Boards.doneWorking);
	},
	onStart:function(event){
		if(Prototype.Browser.IE){ document.onselectstart = function() {return false;}; }
		if(navigator.userAgent.toLowerCase().indexOf('msie 7') < 0){
			var iKey = $(this.mId).readAttribute("position");
			if(iKey != 'EoL' && !Boards.isListView()) {
				var placeHolder = new Element('div');
				placeHolder.id = "mkr-ph";
				placeHolder.setStyle({width: '100%', 'float':'left', 'clear':'left'});
				$("center-panel").insertBefore(placeHolder, $(this.mId).nextSibling);
			}
	
			$(this.mId).setStyle({'width': 'auto', paddingLeft: (Event.pointerX(event) > 95 ? Event.pointerX(event) - 95 : 0) + 'px'});
		}
		$$('#' + this.mId + ' div[class*=gh-marker]').each(function(element){
			GH.Util.addClassName(element, "gh-active");
			Boards.draggedMarker = element; 
		});
		Boards.mainBoard.unselect(true);
	},
	onEnd:function(){
		if(Prototype.Browser.IE){ document.onselectstart = function() {return true;}; }
		if(navigator.userAgent.toLowerCase().indexOf('msie 7') < 0){
			$(this.mId).setStyle({width: '100%', paddingLeft: '0px'});
			if(!Boards.isListView() && $("mkr-ph")){
				$("mkr-ph").remove();
			}
		}
		$$('#' + this.mId + ' div[class*=gh-marker]').each(function(element){
			GH.Util.removeClassName(element, "gh-active");
			GH.Util.removeClassName(element, "gh-downunder");
			Boards.draggedMarker = null; 
		});
	},
	clean:function(){
		// GHS-3117
		// OLD: Droppables.remove($(this.mId));
        AJS.$('#'+this.mId).droppable('destroy');
	}
};
var Board = Class.create();
Board.prototype = 
{
	initialize:function(id){
		this.id = id;
		this.boxId = Boards.selectedProjectId + "_" + this.id;
		this.dropId = Boards.is('TaskBoard') ? 'gh-step_' + this.id : 'drop_' + this.id;
		this.page = new Page(id);
		this.issues = $H();
		this.selectedIssues = $H();
	},
	enableDrop:function(){
		if(!this.isMain()){
			var thisId = this.id;
			var thisBoard = this;
			// GHS-3117:
			// Droppables.remove($(this.dropId)); // we dont want to duplicate
			//Droppables.add(this.dropId, {
			//	accept: ['js-mkr', 'gh-issue-wrapper'],
			//	onDrop: function(element, boxElement, event) {
			//		Boards.droppedBoard = thisBoard;
			//		if (Boards.isPlanningBoard()) {
			//			Boards.cardUpdated(thisId, element, event);
			//		} else {
			//			Boards.updatingStatus(thisId, element);
			//		}
			//	},
			//	hoverclass:'gh-target-hover'
			//});
            AJS.$('#'+this.dropId).droppable('destroy');
            AJS.$('#'+this.dropId).droppable({
                tolerance: 'pointer',
                accept: ('.js-mkr, .gh-issue-wrapper'),
                hoverClass:'gh-target-hover',
                drop: function(event, ui) {
					Boards.droppedBoard = thisBoard;
                    if (Boards.isPlanningBoard()) {
                        Boards.cardUpdated(thisId, ui.draggable.context, event);
                    } else {
                        Boards.updatingStatus(thisId, ui.draggable.context);
					}
                }
            });
		}
	},
	disableDrop:function(){
		// GHS-3117:
		//Droppables.remove($(this.dropId));
        AJS.$('#'+this.dropId).droppable('destroy');
	},
	bulkEdit:function(){
		Boards.submit('GHBulkEdit', $H({issueKeys:this.selectedIssuesQueryString(true)}));
	},
	batchMove:function(parentKey){
		Boards.updater('confirmation', 'Move', $H({key:parentKey, issueKeys:Boards.addSelectedSubs(), start:this.getStart()}), true, Boards.doneWorking);
	},
	getStart:function(){
		return $('start_' + this.id) ? $F('start_' + this.id) : '0';
	},
	addIssue:function(index, id, key, draggable, rankable, scrollId, selectable, parentKey){
		if(Boards.is('TaskBoard') || Boards.inSearchMode || this.isMain()){
			var issue = this.issues.set(key, new Issue(index, id, key, this, draggable, rankable, scrollId, selectable, parentKey));
			issue.enableAll();
			return issue;
		}
	},
	getIssue:function(key){
		return this.issues.get(key);
	},
	getIssueAt:function(index){
		return Boards.getIssueAt(this.issues.values(), index);
	},
	findIssue:function(cardId){
		var issue = this.getIssue(cardId.split("_")[2]);
		return issue ? issue : this.page.getIssue(cardId.split("_")[2]);
	},
	setBoardFilter:function(filterId){
		Boards.updater("confirmation", "SetBoardFilter", $H({boardFilterId:filterId}), true, Boards.doneWorking);
	},
	selectedIssuesQueryString:function(forBulk){
		if(!forBulk && !Boards.draggedIssue) return '';
		var iKeys = "";
		this.selectedIssues.values().each(function(anIssue){
			if(!forBulk){
				GH.Util.hide(anIssue.cKey);
			}
			iKeys = iKeys + anIssue.key + ',';
		});
		return iKeys.substring(0, iKeys.length - 1);
	},
	printChart:function(){
		GH.Util.openWindow(Boards.ctx + '/secure/' + Boards.type() + 'PrintChart.jspa?decorator=none&selectedProjectId=' + Boards.selectedProjectId + '&selectedBoardId=' + this.id + '&chartType=' + $F('chartType') + '&fieldId=' + ($('chartField') ? $F('chartField') : '') + '&forMaster=' + ($('forMaster') ? $F('forMaster') : false), 'GreenHopper');
	},
	showReport:function(){
		window.location=Boards.ctx + '/secure/' + Boards.type() + 'ShowChartReport.jspa?decorator=none&selectedProjectId=' + Boards.selectedProjectId + '&selectedBoardId=' + this.id + '&chartType=' + $F('chartType') + '&fieldId=' + ($('chartField') ? $F('chartField') : '') + '&forMaster=' + ($('forMaster') ? $F('forMaster') : false);
	},
	printCards:function(){
		GH.Util.openWindow(Boards.ctx + '/secure/Print.jspa?decorator=none&selectedProjectId=' + Boards.selectedProjectId + '&selectedBoardId=' + this.id + '&start=' + this.getStart() + '&type=' + Boards.type() + '&printProjectName=' + ($F('gh-print-projectname') ? true : false) + '&printContextName=' + ($F('gh-print-contextname') ? true : false) + '&printBoardName=' + ($F('gh-print-viewingby') ? true : false) + '&printQuickFilter=' + ($F('gh-print-modbar') ? true : false) + '&printIssuesPerPage=' + $F('gh-print-qty'), 'GreenHopper');
		Boards.closePopup();
	},
	printPrep:function(){
		Boards.updater("confirmation", "PrintPrep", $H({selectedBoardId:this.id,start:this.getStart()}), true, Boards.doneWorking);
	},
	setCurveVisibility:function(id){
		Boards.updater("confirmation", "SetCurveVisible", $H({curveVisible:($F('visible_'+id)?true:false), curveId:id}), true, Boards.doneWorking);
	},
	setCurveColor:function(id, color){
		Boards.updater("confirmation", "SetCurveColor", $H({color:color, curveId:id}), true, Boards.doneWorking);
	},
	setChart:function(type, fieldId, forMaster){
		Boards.updater('confirmation', Boards.type() + "SetChartSelection", $H({chartType:type, fieldId:fieldId, forMaster:forMaster}), true, Boards.doneWorking);
	},
	setChartType:function(type){
		this.setChart(type, $('chartField') ? $F('chartField') : '', $('forMaster') ? $F('forMaster') : false);
	},
	setChartField:function(fieldId){
		this.setChart($F('chartType'), fieldId, $('forMaster') ? $F('forMaster') : false);
	},
	setChartMaster:function(forMaster){
		this.setChart($F('chartType'), $('chartField') ? $F('chartField') : '', forMaster);
	},
	toggle:function(){
		if(this.isExpanded()){
			GH.Util.addClassName(this.boxId, 'hidden');
		}
		else{
			GH.Util.removeClassName(this.boxId, 'hidden');
		}
		Boards.request("ToggleBox", $H({dropBoardIds:this.id}));
		// sometimes the box title gets selected (less so if there is a pencil, but always for unscheduled, unknown, etc.
		// Happens in all browsers, so clear without browser check
		Boards.clearTextSelections();
	},
	isExpanded:function(){
		return !GH.Util.hasClassName(this.boxId, 'hidden');
	},
	toggleColumn:function(){
		Boards.working();
		Boards.submit('ToggleColumn', $H({stepId:this.id}));
	},
	initColumns:function(key){
        if(this.resizeColumn(key) && this.getIssue(key)){
            this.getIssue(key).setVisibility();
        }
	},
    resizeColumn:function(key){
        var colKey = this.id + "_" + key + "_children";
        if($(colKey)){
        	var correction = (!Boards.isCompactView() && key == 'orphans' ? 28 : 3); // header heights ???
        	var columns = GH.Util.find("#" + colKey + " [class*=js-step-col]", false);
        	
        	// remove 20 pixels from compact view if we got at least one busted column
        	if (Boards.isCompactView()) {
        		var bustedColumn = false;
                columns.each(function(column){
                	if (GH.Util.hasClassName(column, 'gh-busted-max') || GH.Util.hasClassName(column, 'gh-busted-min')) {
                		bustedColumn = true;
                		throw $break;
                	}
                });
                if (bustedColumn) {
                	correction += 20;
                }
        	}
        	
        	// set the height to all columns
            var height = ($(colKey).getHeight() - correction)+ "px";
            columns.each(function(column){
            	column.style.minHeight = height;
            });
            return true;
        }

        return false;
    },
    resizeAll:function(){
        this.issues.values().each(function(issue){
           if(!issue.board.resizeColumn(issue.key)){
               throw $break;
           };
        });
    },
	enableRanking:function(enable){
		if(enable){
			// GHS-3117
			//Droppables.add('EoL_' + this.id, { accept: ['js-mkr', 'gh-issue-wrapper'], onDrop: function(element){ Boards.lastDrop(element); }, hoverclass:'x'});
            AJS.$('#EoL_'+this.id).droppable({
                tolerance: 'pointer',
                accept: ('.js-mkr, .gh-issue-wrapper'),
                hoverClass:'x',
                drop: function(event, ui) {
                    Boards.lastDrop(ui.draggable.context);
                }
            });
		}
		else{
			// GHS-3117
			//Droppables.remove($('EoL_' + this.id));
            AJS.$('#EoL_'+this.id).droppable('destroy');
		}
	},
	disableDrops:function(){
		this.enableRanking(false);
		this.issues.values().each(function(issue){
			// GHS-3117
			//Droppables.remove($(issue.cKey));
            AJS.$('#'+issue.cKey).droppable('destroy');
		});
	},
	enableDrops:function(){
		this.enableRanking(true);
		this.issues.values().each(function(issue){
			issue.enableDrop();
		});
	},
	notifyPage:function(lock){
		this.page.notifyPage(lock);
	},
	isMain:function(){
		return this.id == Boards.mainBoard.id; 
	},
	colapseAll:function() {
		this.issues.values().each(function(issue){issue.colapseSubs();});
	},
	expandAll:function() {
		this.issues.values().each(function(issue){issue.expandSubs();});
	},
	editMaster:function(){
		Boards.updater('masterEdit_' + this.id, "EditMaster", $H({dropBoardId:this.id}), true, Boards.doneWorking);
	},
	cancelMaster:function(){
		GH.Util.switchView('masterTxt_' + this.id, 'masterEdit_' + this.id);
	},
	updateMaster:function(){
		Boards.updater('confirmation', "SetMaster", $H({dropBoardId:this.id, masterId:$F('masterIn_'+this.id)}), true, Boards.doneWorking);
	},
	release:function(confirmed){
		var params = $H({dropBoardId:($('swap') && $F('swap')?$F('swapVersion'):''), stepId:this.id, confirmed:confirmed});
		if(!Boards.is('TaskBoard') || !confirmed){
			Boards.updater('confirmation', (Boards.is('TaskBoard') ? "TB" : "") + "Release", params, true, Boards.doneWorking);
		}
		else{
			params = params.merge({name:$F('versionName'), releaseDate:$F('releaseDateIn'), endDate:$F('endDateIn'), startDate:$F('stratDateIn'), description:$F('versionDesc')});
			Boards.updater('query-results', "TBRelease", params, true, Boards.success);
		}
	},
	getNWDays:function(){
		Boards.updater('confirmation', "NWDays", $H({dropBoardId:this.id}), true, Boards.doneWorking);
	},
	addNWDay:function(refresh){
		if(!$F('nwDate')) return;
		Boards.updater("gh-nwd", "PBAddNWDay", $H({dropBoardId:this.id, nonWorkingDay:$F('nwDate'), refresh:refresh}), true, Boards.doneWorking);
	},
	removeNWDay:function(nwDate,refresh){
		Boards.updater("gh-nwd", "PBRemoveNWDay", $H({dropBoardId:this.id, nonWorkingDay:nwDate, refresh:refresh}), true, Boards.doneWorking);
	},
	resetNWDInputs:function(refresh){
		Boards.needsRefresh = refresh;
		GH.Util.write('query-results', '');
		$('nwDate').value='';
	},
	gotoMarker:function(event, markerId){
		Boards.getMarker(markerId).jumpTo(this);
		event = GH.Util.getEvent(event);
		if (event) Event.stop(event);
	},
	setMarker:function(markerId, value){
		Boards.getMarker(markerId).set(this, value);
	},
	moveMarker:function(markerId, position, value, txt, capacitySet){
		Boards.getMarker(markerId).move(this, position, value, txt, capacitySet);
	},
	setIssueDisplay:function(issueDisplay){
		Boards.working();
		Boards.submit("SetIssueDisplay", $H({issueDisplay:issueDisplay, start:this.getStart()}));
	},
	setIssueDisplay2:function(issueDisplay){
		Boards.working();
		Boards.updater("confirmation", "ChangeCardDisplay", $H({issueDisplay:issueDisplay, start:this.getStart()}));
		return false;
	},
	selectBoard:function(startIdx){
		if(this.isMain()) return;
		var oldMain = Boards.mainBoard;
		Boards.mainBoard = this;
		
		oldMain.clean();
		oldMain.enableDrop();
		GH.Util.removeClassName(oldMain.dropId, 'gh-selected');
		GH.Util.addClassName(Boards.mainBoard.dropId, 'gh-selected');

		this.refreshMainBoard(startIdx);
		this.refreshBreadcrumbs();
	},
	refreshBreadcrumbs:function(){
		if(!Boards.is('TaskBoard')){
			Boards.updater('gh-breadcrumbs', Boards.type() + "RefreshBreadcrumbs", $H({selectedBoardId:this.id}), true, Boards.doneWorking);
		}
	},
    refreshMainBoard:function(startIdx, issueKeys){
        // For the timetracking analysis and release notes we want to reload the
        // page to ensure the board/column is properly loaded
		if(!Boards.is('TaskBoard') && !$('tanalysis')){
			this.clean();
			Boards.resetMarkers();
			Boards.updater(this.focus(), Boards.type() + "RefreshBoard", $H({selectedBoardId:this.id, start:(startIdx != null ? startIdx : this.getStart()), issueKeys: (issueKeys ? issueKeys : "")}), true, Boards.doneWorking);
		}
		else{
            Boards.reloadBoard();
		}
    },
//    refreshMainBoard:function(startIdx, issueKeys){
//        var params = $H({selectedBoardId:this.id, start:(startIdx != null ? startIdx : this.getStart()), issueKeys: (issueKeys ? issueKeys : "")});
//        Boards.reloadBoard(params);
//    },
	refreshMainBoardSelected:function(startIdx){
		if (!Boards.isPlanningBoard() || Boards.inSearchMode) return;
		this.clean();
		Boards.resetMarkers();
		Boards.updater(this.focus(), "RefreshBoardSelected", $H({selectedBoardId:this.id, start:startIdx, oldStart:this.getStart()}), true, Boards.doneWorking);
	},
	focus:function(){
		var containerId = 'mainBoard_' + this.id;
		$$('#gh-issues div[class*="js-main"]').each(function(el){el.id = containerId});
		return containerId;
	},
	refreshBox:function(startIdx){
		if(this.isMain()){
			this.refreshMarkers();
		}
		Boards.updater('box_'+this.id, Boards.type() + "RefreshDrop", $H({dropBoardId:this.id, selectedBoardId:Boards.mainBoard.id}), true, Boards.doneWorking);
	},
	refreshStepBoard:function(startIdx){
		this.clearIssues();
		// GHS-3117 TODO
        // AJS.$('#gh-step-outer_'+this.id).children().droppable('destroy');
		Boards.updater('gh-step-outer_'+this.id, "RefreshStep", $H({stepId:this.id, stepStart:(startIdx ? startIdx : this.getStart())}), true, Boards.doneWorking);
	},
	refreshParentStep:function(startIdx){
		Boards.submit("TaskBoard", $H({selectedBoardId:this.id, start:startIdx}));
	},
	clean:function(){
		this.page.hide();
		this.page.clean();
		// GHS-3117 TODO: js-page-drop li handling?
	    //$$("span[class*=js-page-drop]").each(function(pageDrop){
		//	Droppables.remove(pageDrop);
		//});
	    //Droppables.remove($('drop_' + this.id));
	    //Droppables.remove($('EoL_' + this.id));
		AJS.$('li.js-page-drop').droppable('destroy');
        AJS.$('#drop_' + this.id).droppable('destroy');
        AJS.$('#EoL_' + this.id).droppable('destroy');
		this.clearIssues();
	},
	clearIssues:function(){
		var thisIssues = this.issues;
		var thisSelectedIssues = this.selectedIssues;
		this.issues.each(function(pair){
			thisSelectedIssues.unset(pair.key);
			thisIssues.unset(pair.key).clear();
		});
	},
	hierarchy:function(){
		Boards.submit("ConfigureReport",$H({decorator:'', reportKey:'com.pyxis.jira.links.hierarchy.reports:pyxis.hierarchy.report.version', versionId:this.id, linkTypeId:Boards.linkId, subtasks:true, hierarchyView:'tree', orphans:true, Next:'Next'}));
	},
	selectOrFind:function(iKey){
		if(this.getIssue(iKey)) this.selectOn([iKey], true);
		else Boards.getBoardForIssue(iKey, Boards.type(), true);
	},
	getDescription:function(){
		Boards.updater("confirmation", "GetDescription", $H({}), true, Boards.doneWorking);
	},
	getColCapacity:function(){
		Boards.updater("confirmation", "GetTBCapacity", $H({stepId:this.id}), true, Boards.doneWorking);
	},
	setColCapacity:function(fieldId){
		GH.Util.show('Stats_wait');
		Boards.updater('statistics-table', 'SetTBCapacity', $H({stepId:this.id, fieldId:fieldId, maxCapacity:$F(fieldId+'_max'), minCapacity:$F(fieldId+'_min')}), true, Boards.doneWorking);
	},
	editCapacity:function(event, fieldId){
		// cancel all edits if a link was clicked, so we don't see the edit box while waiting
		// for the page to refresh (links change the view)
		if (event){
			event = GH.Util.getEvent(event);
			if(event && GH.Util.getEvent(event).element().nodeName == "A"){
				return;
			}
		} 
		
		GH.Util.write(fieldId+'_'+this.id+'_edit', '');
		Boards.updater(fieldId+'_'+this.id+'_edit', "EditCapacity", $H({dropBoardId:this.id, fieldId:fieldId}), true, Boards.success);
	},
	setCapacity:function(fieldId){
		Boards.updater("confirmation", "SetCapacity", $H({dropBoardId:this.id, fieldId:fieldId, minCapacity:$F(fieldId+'_'+this.id+'_min'), maxCapacity:$F(fieldId+'_'+this.id+'_max') }), false, Boards.success);
	},
	cancelCapacity:function(fieldId){
		GH.Util.switchView(fieldId+'_'+this.id, fieldId+'_'+this.id+'_edit');
	},
	firstSelection:function(){
		return this.selectedIssues.size() > 0 ? this.selectedIssues.values()[0].key : '';
	},
	selectOn:function(iKeys, anchored){
		this.unselect(true);
		if(iKeys){
			for(var i = 0; i < iKeys.size(); i++){
				if(this.issues.get(iKeys[i])){
					this.issues.get(iKeys[i]).doSelect(anchored);
					anchored = false;
				}
			}
		}
	},
	unselect:function(includeThisBoard, notThisKey){
		var thisId = this.id;
		Boards.boards.values().each(function(board){
			// unselect issues of all other boards
			if(board.id != thisId){
				board.selectedIssues.values().each(function(issue){if(issue.key != notThisKey)issue.unselect();});
			}
			// also of this board if necessary
			else if(includeThisBoard){
				board.selectedIssues.values().each(function(issue){if(issue.key != notThisKey)issue.unselect();});
			}
		});
	},
	editDate:function(date){
		GH.Util.setValueWithHTML(date+'In_'+ this.id, date+'Date_'+this.id);
		GH.Util.switchView(date+'Edit_'+this.id, date+'Txt_'+this.id);
	},
	cancelDate:function(date){
		GH.Util.switchView(date+'Txt_'+this.id, date+'Edit_'+this.id);
	},
	updateDate:function(date){
		Boards.updater('confirmation', "Set" + date + "Date", $H({dropBoardId:this.id, date:$F(date+'In_'+this.id)}), true, Boards.doneWorking);
	},
	editName:function(){
		if(this.isMain()){
			GH.Util.setValueWithHTML('nameIn_'+ this.id, 'name_'+this.id);
			GH.Util.switchView('nameEdit_'+this.id, 'nameTxt_'+this.id);
		}
	},
	cancelName:function(){
		GH.Util.switchView('nameTxt_'+this.id, 'nameEdit_'+this.id);
	},
	refreshMarkers:function(){
		if(!Boards.inSearchMode){
			var thisBoard = this;
			AJS.$("div.js-mkr").each(function(index, marker){
				thisBoard.gotoMarker(null, marker.id.split("marker_")[1]);
			});
			Boards.doneWorking();
		}
	},
	cancel:function(iKeys, doRefresh){
		if(Boards.inSearchMode){
			if(doRefresh){
				Boards.retrieve($F('searchKey'), $F('searchType'));
			}
			else{
				this.selectOn(iKeys);
				Boards.returnToSearch();
			}
		}
		else{
			Boards.needsRefresh = doRefresh;
			if (iKeys && iKeys.length > 0) {
				this.selectOn(iKeys);
			}
			Boards.closePopup();
		}
	},
	updateName:function(){
		if(GH.Util.trim($F('nameIn_'+this.id))=='') return;
		Boards.updater('confirmation', "Name", $H({dropBoardId:this.id, name:$F('nameIn_'+this.id)}), true, Boards.doneWorking);
	},
	selectNextIssue:function(doPageChange){
		// fetch the issue count, return if we got any issues
		var issueCount = this.issues.values().size();
		if (issueCount < 1) return;
		
		// fetch the next index to select
		var indexToSelect, currentSelected;
		var selectedIssues = this.selectedIssues.values();
		if (selectedIssues.size() > 0) {
			currentSelected = selectedIssues.first();
		}
		indexToSelect = this.findNextSelectable(currentSelected);
		
        // select if we got a next index to select
        if (indexToSelect) {
        	var issueToSelect = this.getIssueAt(indexToSelect);
        	if (issueToSelect){
			    this.unselect(true, issueToSelect.key);
	            issueToSelect.select(true);
	        }
        }
        // navigate to next page instead
        else if (doPageChange){
        	this.selectNextPage();
        }
	},
	findNextSelectable:function(currentSelected) {
		// get all issues sorted by index
		var values = this.issues.values().sortBy(function(issue) { return issue.index; });
		var lastIndex = values.last().index;
		if (currentSelected) {
			var currentIndex = currentSelected.index + 1;
		} else {
			var currentIndex = values.first().index;
		}
        while (currentIndex <= lastIndex) {
        	var tmpIssue = this.getIssueAt(currentIndex); 
            if (tmpIssue && tmpIssue.selectable && tmpIssue.isVisible()) {
            	return currentIndex;
            }
            currentIndex++;
        }
	},
	selectPreviousIssue:function(doPageChange){
		// abord if we got no issues
		var issueCount = this.issues.values().size();
		if (issueCount < 1) return;
		
		// fetch the previous index to select
		var indexToSelect, currentSelected;
		var selectedIssues = this.selectedIssues.values();
		if (selectedIssues.size() > 0) {
			currentSelected = selectedIssues.first();
		}
		indexToSelect = this.findPreviousSelectable(currentSelected);
        
        // select if indexToSelect is valid
        if (indexToSelect) {
        	var issueToSelect = this.getIssueAt(indexToSelect);
        	if (issueToSelect){
			    this.unselect(true, issueToSelect.key);
	            issueToSelect.select(true);
	        }
        }
        // navigate to previous page instead
        else if (doPageChange) {
        	this.selectPreviousPage();
        }
	},
	findPreviousSelectable:function(currentSelected) {
		// get all issues sorted by index
		var values = this.issues.values().sortBy(function(issue) { return issue.index; });
		var firstIndex = values.first().index;
		if (currentSelected) {
			var currentIndex = currentSelected.index - 1;
		} else {
			var currentIndex = values.last().index;
		}
		
        // find the previous selectable index
        while (firstIndex <= currentIndex) {
        	var tmpIssue = this.getIssueAt(currentIndex);
            if (tmpIssue && tmpIssue.selectable && tmpIssue.isVisible()) {
            	return currentIndex;
            }
            currentIndex--;
        }
	},
	selectNextPage: function(){
		var currPageStart = this.getStart();
		var pageStarts = this.otherPageStarts();
		var nextPageStart;
		pageStarts.each(function(index){
			if (currPageStart < index) {
				nextPageStart = index;
				throw $break;
			}
		});
		if (nextPageStart) {
			 this.refreshMainBoardSelected(nextPageStart);
		}
	},
	selectPreviousPage: function(){
		var currPageStart = this.getStart();
		var pageStarts = this.otherPageStarts();
		var prevPageStart;
		pageStarts.each(function(index){
			if (currPageStart < index) {
				throw $break;
			}
			prevPageStart = index;
		});
		if (prevPageStart < currPageStart) {
			 this.refreshMainBoardSelected(prevPageStart);
		}
	},
	otherPageStarts: function(){
		var pageStarts = $A();
		AJS.$('#gh-paginate .js-page-num').each(function(index){
			pageStarts.push(parseInt(AJS.$(this).attr('id').split("-").last()));
		});
		return pageStarts;
	},
	cancelEdit:function(){
		$$('#box_'+this.id + ' [class*="js-edit"]').each(function(field){
			GH.Util.hide(field);
		});
		$$('#box_'+this.id + ' [class*="js-editable"]').each(function(field){
			GH.Util.show(field);
		});
	}
};
var Issue = Class.create();
Issue.prototype = 
{
	initialize:function(index, id, key, board, draggable, rankable, scrollId, selectable, parentKey){
		this.board = board;
		this.id = id;
		this.key = key; 
		this.cKey = 'gh-issue_' + board.id + "_" + key;
		this.grabber = 'gh-grab_' + board.id + "_" + key;
		this.dragElement; this.parentIssue;
		this.parentKey = parentKey?parentKey:'';
		this.index = index;
		this.draggable = draggable;
		this.rankable = rankable;
		this.scrollId = scrollId;
		this.selectable = selectable;
		this.height;
		this.setZIndex();
	},
	isInListView:function(){
	  // if we are in list view, check whether the issue has been toggled to a card
	  if (! Boards.isListView()) return false;
	  return AJS.$('#'+this.cKey).children('.gh-cards').length == 0;
	},
	enableMenu:function(){
		if($("gh-menu_" + this.board.id + "_" + this.key)){
			AJS.$("#gh-menu_" + this.board.id + "_" + this.key).dropDown();
		}
	},
	setZIndex:function(){
		if((!Boards.is('TaskBoard') || Prototype.Browser.IE) && $(this.cKey)){
			$(this.cKey).style.zIndex = Math.max(0, 999 - this.index);
		}
	},
	disableAll:function(){
		// GHS-3117
		//Droppables.remove($(this.cKey));
		//Draggables.unregister($(this.cKey));
        AJS.$('#'+this.cKey).droppable('destroy').draggable('destroy');
		if(this.dragElement){
			this.dragElement.destroy();
			this.dragElement = null;
		}
	},
	enableAll:function(){
		this.disableAll();
		this.enableDrop();
		this.enableDrag();
		this.enableMenu();
	},
	enableDrag:function(){
		if(!this.rankable && !this.draggable) return;
		
		// GHS-3117
		var constraint = '';
		if(this.rankable && Boards.isListView() && Boards.inSearchMode){
			constraint = "y";
		}
		else if(this.draggable && Boards.is("TaskBoard")){
			constraint = "x";
		}
        if(Boards.inSearchMode){
            dragContainer = ".body-with-scroll-s";
        }
        else {
            dragContainer = false;
        }
        var thisIssue = this;
        AJS.$('#'+this.cKey).draggable({
            revert: true,
            revertDuration: 0,
            axis: constraint,
            containment: dragContainer,
            zIndex: 3000,
            opacity: 0.7,
            helper: function() {
            	var draggedElement = AJS.$(this); 
            	var clone = draggedElement.clone();
            	clone.children().remove('script');
            	var position = draggedElement.position();
            	clone.css({top: position.top, left: position.left });
            	return clone;
            },
            refreshPositions: true,
            start: function(event, ui) {
                thisIssue.issueDragStart(event, ui);

                // GHS-3117: TODO: Do we still need this?
				// attach the drop listener, but only if we are not in list view/planning board,
				// as there the shape of the dragged element changes, thus no click is consumed at the end
				// of the dnd operation
				//if (! (Boards.isPlanningBoard() && thisIssue.isInListView())) {
				//  GH.CardDragClickHandler.strip(event.element());
				//}
            },
            stop: function(event, ui) {
                thisIssue.issueDragStop(event, ui);
            }
        });
		//this.dragElement = new Draggable(this.cKey, {
		//	scroll: (this.scrollId == 'window' ? window : $(this.scrollId)),
		//	ghosting:false,
		//	reverteffect: function(element){
		//		$(element).setStyle({'left': '0px', 'top':'0px'});
        //	},
        //	revert: true,
        //	constraint: constraint,
        //	onStart: function(draggable, event){
        //		thisIssue.cardMoved(event, draggable.element);

        //		// attach the drop listener, but only if we are not in list view/planning board,
        //		// as there the shape of the dragged element changes, thus no click is consumed at the end
        //		// of the dnd operation
        //		if (! (Boards.isPlanningBoard() && thisIssue.isInListView())) {
        //		  GH.CardDragClickHandler.strip(event.element());
        //		}

        //	},
        //	onEnd: function(draggable, event){
        //		thisIssue.cardStopped(event, draggable.element);
        //	}
        //});
	},
	enableDrop:function(){
		if(!this.rankable) return;
		//Droppables.remove($(this.cKey)); // prevent duplicatas
        AJS.$('#'+this.cKey).droppable('destroy');

		var thisIssue = this;
		// GHS-3117: over and out handle correct padding (through active/deactivate calls)
		//Droppables.add(this.cKey, { accept: ['js-mkr', 'gh-issue-wrapper'], onDrop: function(element){ thisIssue.cardDropped(element); }, hoverclass:(Boards.isListView() || this.board instanceof Page ? null : 'gh-target-hover')});
        AJS.$('#'+this.cKey).droppable({
            tolerance: 'pointer',
            accept: ('.js-mkr,.gh-issue-wrapper'),
            hoverClass:(Boards.isListView() || this.board instanceof Page ? null : 'gh-target-hover'),
            drop: function(event, ui) {
                thisIssue.cardDropped(ui.draggable.context);
                // the second selector is for top padding the issues in the preview panel when we're not in list view
                if (Boards.isListView()||AJS.$('#'+this.id).parents().hasClass('gh-main-pagine')){
                    var issue = Boards.findIssue(this.id);
                    if (issue) {
                        issue.deactivate();
                    }
                }
            },
            over: function(event, ui) {
                if (Boards.isListView()||AJS.$('#'+this.id).parents().hasClass('gh-main-pagine')){
                    var issue = Boards.findIssue(this.id);
                    if (issue) {
                        issue.activate();
                    }
                }
            },
            out: function(event, ui) {
                if (Boards.isListView()||AJS.$('#'+this.id).parents().hasClass('gh-main-pagine')){
                    var issue = Boards.findIssue(this.id);
                    if (issue) {
                        issue.deactivate();
                    }
                }
            }
        });
	},
	isSubtask:function(){
		return this.parentKey != '';
	},
	getSubtasks:function(){
		if(this.isSubtask()) return [];
		
		var i=0;
		var subs=[];
		var parentKey = this.key;
		this.board.issues.values().each(function(issue){
			if(issue.parentKey == parentKey){
				subs[i++]=issue;
			}
		});
		return subs.sortBy(function(issue) { return issue.index; });
	},
	getParent:function(){
		if(this.parentIssue == null){
			this.parentIssue = this.board.getIssue(this.parentKey);
		}
		
		return this.parentIssue;
	},
	move:function(dropKey){
		var idrop = Boards.focussedBoard().getIssue(dropKey);
		if(idrop.parentKey != this.parentKey) return;
		else if(idrop.index < this.index){ this.moveBefore(idrop);}
		else{ this.moveAfter(idrop);}
	},
	moveBefore:function(idrop){
		var maxIndex = this.index;
		$("center-panel").insertBefore($(this.cKey), $(idrop.cKey));
		idrop.board.issues.values().each(function(anIssue){
			if(anIssue.index < maxIndex && anIssue.index >= idrop.index){
				anIssue.index++;
				anIssue.setZIndex();
			}
		});
		this.index = idrop.index-1;
		this.setZIndex();
		this.moveSubs(idrop);
		this.doSelect();
	},
	moveAfter:function(idrop){
		var minIndex = this.index;
		var subs = idrop.getSubtasks();
		idrop = subs.size() > 0 ? subs.last() : idrop;
		if(idrop.board.issues.size() == idrop.index) {
			$("center-panel").appendChild($(this.cKey));
		} 
		else {
			$("center-panel").insertBefore($(this.cKey), $(idrop.cKey).nextSibling);
		}
		idrop.board.issues.values().each(function(anIssue){
			if(anIssue.index > minIndex && anIssue.index <= idrop.index){ 
				anIssue.index--;
				anIssue.setZIndex();
			}
		});
		this.index = idrop.index+1;
		this.setZIndex();
		this.moveSubs(idrop);
		this.doSelect();
	},
	moveSubs:function(idrop){
		if(!this.isSubtask()){
			var parentIssue = this;
			this.getSubtasks().each(function(issue){
				if(parentIssue.board.issues.size() == parentIssue.index) { 
					$("center-panel").appendChild($(issue.cKey)); 
				}
				else { 
					$("center-panel").insertBefore($(issue.cKey), $(parentIssue.cKey).nextSibling); 
				}
				idrop.board.issues.values().each(function(anIssue){
					if(idrop.index < issue.index && anIssue.index < issue.index && anIssue.index > parentIssue.index){ 
						anIssue.index++; 
					}
					else if(anIssue.index > issue.index && anIssue.index <= parentIssue.index){	
						anIssue.index--;
					} 
					anIssue.setZIndex();
				});
				issue.index = parentIssue.index + 1;
				issue.setZIndex();
				
				parentIssue = issue;
			});
		}
	},
	toggleSubs:function(){
		if(!$('colapse_' + this.key))return;
		if(GH.Util.hasClassName('colapse_' + this.key, 'gh-open')){
			this.colapseSubs();
		}
		else{
			this.expandSubs();
		}
	},
	colapseSubs:function(){
		Boards.cookies.setData(this.id, '1');
		GH.Util.addClassName('colapse_' + this.key, 'gh-close');
		GH.Util.removeClassName('colapse_' + this.key, 'gh-open');
		this.getSubtasks().each(function(sub){GH.Util.addClassName(sub.cKey, 'hidden');});
		GH.Util.addClassName(this.board.id + "_" + this.key + "_toggle", 'hidden');
	},
	expandSubs:function(){
		Boards.cookies.removeData(this.id);
		GH.Util.addClassName('colapse_' + this.key, 'gh-open');
		GH.Util.removeClassName('colapse_' + this.key, 'gh-close');
		this.getSubtasks().each(function(sub){GH.Util.removeClassName(sub.cKey, 'hidden');});
		GH.Util.removeClassName(this.board.id + "_" + this.key + "_toggle", 'hidden');
	},
	isVisible:function(){
		return ! GH.Util.hasClassName(this.cKey, 'hidden');
	},
	setVisibility:function(){
		if(this.isSubtask() && !this.getParent()) return;
		var colKey = this.isSubtask() ? this.parentKey : this.key;
		if($('colapse_' + colKey)){
			GH.Util.show('colapse_' + colKey);
			
			if(Boards.cookies.getData(this.isSubtask() ? this.getParent().id : this.id)){
				if(GH.Util.hasClassName('colapse_' + colKey, 'gh-open')){
					GH.Util.addClassName('colapse_' + colKey, 'gh-close');
					GH.Util.removeClassName('colapse_' + colKey, 'gh-open');
				}
				if(this.isSubtask()){
					GH.Util.addClassName(this.cKey, 'hidden');
				}
				else{
					GH.Util.addClassName(this.board.id + "_" + this.key + "_toggle", 'hidden');
				}
			}
		}
	},
	doAction:function(action){
		this.issueUpdater(action);
	},
	doDelete:function(){
		this.issueUpdater('Delete', $H({}), 'query-results');
	},
	toggleFlag:function(){
		this.doAction((Boards.isTaskBoard()?"TB":"") + "Flag");
	},
	updatingStatus:function(newStepId){
		Boards.updater('confirmation', "UpdatingStatus", $H({key:this.key, stepId:this.board.id, newStepId:newStepId}), false, Boards.success);
	},
	updateStatus:function(newStepId){
		var transitionRadio = AJS.$('#task-options input[data-name="tx"]:checked');
		var resolutionRadio = AJS.$('#task-options input[data-name="res"]:checked');
		if(transitionRadio.size()==0 && resolutionRadio.size()==0) return;
		
		// make sure we disable the buttons and unregister the access keys
		AJS.$('#gh-wfaction, div.gh-board-transition a.button-panel-cancel-link').attr({ disabled: true}).removeAttr('accessKey');
		
		if (transitionRadio.size() > 0) {
			var actionId = transitionRadio.val();
			var xsrfToken = AJS.$('#task-options input[name=xsrfToken]').val();
			this.startWorkflowTransition(actionId, xsrfToken);
		}
		else {
			var action = resolutionRadio.val();
			// perform a resolution change
			var params = $H({id:this.id, action:action, stepId:this.board.id, newStepId:newStepId});
			if($('resolution_'+action))params = params.merge({resolution:$F('resolution_'+action)});
			Boards.updater('confirmation', "ChangeResolution", params, false, Boards.success);
		}
	},
	startWorkflowTransition:function(actionId, xsrfToken){
		// make sure the issue is selected
		this.cancelEdit();
		this.board.unselect(true, this.key);
		this.select();
		
		// hack to make it work for the parent issues in the outline view
		// all other issues should already be selected by now
		this.board.selectedIssues.set(this.key, this);
		
		var url = GH.CONFIG.requestContext
				+ '/secure/WorkflowUIDispatcher.jspa?id={0}&action='
				+ actionId
				+ '&atl_token='
				+ xsrfToken
				+ '&returnUrl='; // not used in our case
		var link = '<a href="'+url+'" class="issueaction-workflow-transition"></a>';
		var $link = AJS.$(link);
		$link.click();
	},
	editLabel:function(event, customFieldId) {
		// cancel all edits if a link was clicked, so we don't see the edit box while waiting
		// for the page to refresh (links change the view)
		event = GH.Util.getEvent(event);
		if (event && event.element().nodeName == "A") return;
		
		// make sure the issue is selected
		this.cancelEdit();
		this.board.unselect(true, this.key);
		this.select();
		
		// hack to make it work for the parent issues in the outline view
		// all other issues should already be selected by now
		this.board.selectedIssues.set(this.key, this);
		
		// label editing is done through a dialog, triggered by a live event. the link url will have to contain the customFieldId in order to get
		var url = GH.CONFIG.requestContext
				 + '/secure/EditLabels!default.jspa?id={0}&noLink=false'
				 + (customFieldId ? '&customFieldId='+customFieldId : '')
				 + '&returnUrl='; // not used anyways in our implementation
		var link = '<a href="'+url+'" class="edit-labels"></a>';
		var $link = AJS.$(link);
		$link.click();
	},
	logWork:function(){
		// make sure the issue is selected
		this.cancelEdit();
		this.board.unselect(true, this.key);
		this.select();
		
		// hack to make it work for the parent issues in the outline view
		// all other issues should already be selected by now
		this.board.selectedIssues.set(this.key, this);
		
		// trigger the log work action link
		AJS.$('a.issueaction-log-work').trigger('click');
	},
	editField:function(event, fieldId){
		// cancel all edits if a link was clicked, so we don't see the edit box while waiting
		// for the page to refresh (links change the view)
		event = GH.Util.getEvent(event);
		if (event && event.element().nodeName == "A") return;
		
		// hack to work around IE triggering click events upon dropping a card
		// dropped cards are not visible anymore, so just return if the card isn't visible
		if (!GH.Util.isVisible(this.cKey)) return;
		
		this.cancelEdit();
		GH.Util.addClassName(this.cKey, 'gh-edit-active');
		GH.Util.addClassName(this.board.id + '_' + this.key + '_' + fieldId, 'gh-edit-active');
		this.issueUpdater((Boards.isTaskBoard()?"TB":"") +"EditField", $H({fieldId:fieldId}), "edit_" + this.board.id + '_' + this.key + '_' + fieldId);
	},
	editCFU:function(id, picker, multi){
		this.editCFS(id);
		id = this.key + '_' + id;
	    Boards.winPicker = GH.Util.openWindow(Boards.ctx+'/secure/popups/'+picker+'Browser.jspa?formName=form_' + id + (multi ? '&multiSelect=true' : '') + '&element=cfIn_' + id, picker);
	    Boards.winPicker.opener = self;
	    Boards.winPicker.focus();
	},
	updatingPriority:function(){
		// only allow editing the priority if it is shown
		var priorityShown = AJS.$('#'+this.cKey+' .js-issue-priority-shown').size() > 0;
		if (priorityShown) {
			this.updatingField('priority');
		}
	},
	updatingField:function(fieldId){
		this.issueUpdater((Boards.isTaskBoard()?"TB":"")+"UpdatingField", $H({fieldId:fieldId}));
	},
	updateField:function(fieldId, fieldValue){
		var fieldValueId = "in_" + this.board.id + '_' + this.key + '_' + fieldId;
		if(!Boards.inSearchMode && (fieldId == 'fixVersions' && Boards.is('VersionBoard') || fieldId == 'components' && Boards.is('ComponentBoard') || fieldId == 'assignee' && Boards.is('AssigneeBoard'))){
			Boards.updater('confirmation', "Updating", $H({issueKeys:this.key, fieldId:fieldId, dropBoardId:(fieldValue ? fieldValue : $F(fieldValueId)), selectedBoardId:this.board.id}), false, Boards.success); 
		}
		else{
			this.issueUpdater((Boards.isTaskBoard()?"TB":"")+"UpdateField", $H({fieldId:fieldId, fieldValue:(fieldValue ? fieldValue : $F(fieldValueId))}));
		}
	},
	updatePField:function(fieldId){
		var fieldValueId = "newField_" + fieldId;
		if(!Boards.inSearchMode && (fieldId == 'fixVersions' && Boards.is('VersionBoard') || fieldId == 'components' && Boards.is('ComponentBoard') || fieldId == 'assignee' && Boards.is('AssigneeBoard'))){
			Boards.updater('confirmation', "Updating", $H({issueKeys:this.key, fieldId:fieldId, dropBoardId: $F(fieldValueId), selectedBoardId:this.board.id}), false, Boards.success); 
		}
		else{
			this.issueUpdater((Boards.isTaskBoard()?"TB":"") + "UpdatePField", $H({fieldId: fieldId, fieldValue: $F(fieldValueId)}), 'query-results');
		} 
	},
	showFieldEdit:function(fieldId, calendarFormat){
		GH.Util.switchView("edit_" + this.board.id + '_' + this.key + '_' + fieldId, "txt_" + this.board.id + '_' + this.key + '_' + fieldId);
		Boards.ffocus("in_" + this.board.id + '_' + this.key + '_' + fieldId);
	},
    buildMenu:function(){
		var menuId = "gh-menu_" + this.board.id + "_" + this.key;
		GH.Util.show(menuId);
		var width = $(menuId+'-dd').getWidth();
		var height = $(menuId+'-dd').getHeight();
		$(menuId + '-dd-s').setStyle({'display':'block', 'width':(width+16)+'px', 'height':(height+14)+'px', 'left':'0px'});
    	$(menuId + '-dd-s').innerHTML='<div class="tl" style="left: 1px;"></div><div class="tr"></div><div class="l" style="height:'+(height-8)+'px;left: 1px;"></div><div class="r" style="height:'+(height-8)+'px;"></div><div class="bl"></div><div class="br"></div><div class="b" style="width:'+(width-12)+'px;"></div>';
    },
	openMenu:function(){
		this.cancelEdit();
		if(GH.Util.innerValue("gh-menu_" + this.board.id + "_" + this.key) == ''){
			this.issueUpdater("Get" + Boards.type() + "CardMenu", $H({}), "gh-menu_" + this.board.id + "_" + this.key);
		}
		else{
			GH.Util.show("gh-menu_" + this.board.id + "_" + this.key);
		}
	},
	closeMenu:function(){
		GH.Util.hide("gh-menu_" + this.board.id + "_" + this.key);
	},
	toggle:function(){
		if($$('#' + this.cKey + ' [class*="gh-edit-active"]').size() > 0) return;
		this.issueUpdater((Boards.isTaskBoard()?"TB":"") + "ToggleCard", $H({}), this.cKey);
		// work around IE selecting the card text when toggling the card
		if(Prototype.Browser.IE){
			Boards.clearTextSelections();
		}
	},
	issueUpdater:function(jspa, params, destination){
		GH.Util.hide("gh-menu_" + this.board.id + "_" + this.key);
		params = params ? params : $H({});
		params = params.merge($H({key:this.key, id:this.id, stepId:this.board.id}));
		Boards.updater((destination?destination:'confirmation'), jspa, params, true, Boards.doneWorking);
	},
	isEditing:function(){
		return Boards.winPicker || GH.Util.hasClassName(this.cKey, 'gh-edit-active');
	},
	cancelEdit:function(){
		Try.these(function(){if(Boards.winPicker)Boards.winPicker.close();});
		GH.Util.removeClassName(this.cKey, 'gh-edit-active');

		var cardKey = this.cKey;
		$$('#' + this.cKey + ' [class*="js-fedit"]').each(function(field){
			GH.Util.removeClassName(field.parentNode.id, 'gh-edit-active');
			GH.Util.hide(field);
		});
		$$('#' + this.cKey + ' [class*="js-ftext"]').each(function(field){
			GH.Util.show(field);
		});
	},
	
	/*********************************    DRAG & DROP EVENTS    *********************************/

    // replacement jQuery version of cardMoved
    issueDragStart:function(event, ui){
        Boards.draggedIssue = this;
        AJS.$('#'+this.cKey).addClass('gh-drag-placeholder');
        AJS.$(ui.helper).addClass('gh-move-main');
		if(this.isSelected()) {
	        if(this.board.selectedIssues.size() > 1){
                AJS.$(ui.helper).prepend(AJS.$('<div id="gh-move-count"><em>'+this.board.selectedIssues.size()+'</em></div>'));
	        }
        }
        else{
            this.board.unselect(true);
            this.select();
        }

        if (this.isInListView() && Boards.isPlanningBoard() && !Boards.inSearchMode) {
        	// adjust the position since the list view shortens the line. The min-width keeps the layout
        	// intact when dragging from the right end.
        	var leftPadding = event.clientX - 40;
        	if (leftPadding < 0) leftPadding = 0;
            AJS.$(ui.helper).css({
            	'padding-left' : leftPadding,
            	'min-width' : AJS.$('#' + this.cKey + " .gh-subhead").outerWidth() + 10
            });
        }

        // IE7 fix for z-index under-lapping bs
        if (navigator.userAgent.toLowerCase().indexOf('msie 7') > -1) {

            var ancest = AJS.$('#'+this.cKey).parentsUntil('#gh-issues');
            AJS.$(ancest).each(function(index,el){
                el = AJS.$(el);
                var pos = el.css('position');
                if (pos == 'relative' || pos == 'absolute' || pos == 'fixed') {
                    var z = el.css('z-index');
                    GH.IE7.zIndexCache[el] = z;
                    el.css({'z-index':'3000'});
                }

            });

        }

    },
    issueDragStop:function(event, ui){
        AJS.$('#'+this.cKey).removeClass('gh-drag-placeholder');
        Boards.draggedIssue = null;

        // IE7 fix for z-index underlapping bs
        if (navigator.userAgent.toLowerCase().indexOf('msie 7') > -1) {

            var disturbed = GH.IE7.zIndexCache;
            AJS.$(disturbed).each(function(el,z){
                el = AJS.$(el);
                el.css({'z-index':z});
            });
            GH.IE7.zIndexCache = {};

        }


    },
    // @todo remove these apres testing
//	cardMoved:function(event, element){
//        Boards.draggedIssue = this;
//		if(Prototype.Browser.IE){
//			document.onselectstart = function() {return false;};
//		}
//		if(this.isSelected()) {
//	        if(this.board.selectedIssues.size() > 1){
//                var moveCount = $('gh-move-count');
//                GH.Util.write($$("#gh-move-count em")[0], this.board.selectedIssues.size());
//	        	GH.Util.insertTop($$("#"+this.cKey)[0], moveCount);
//                GH.Util.addClassName(this.cKey, 'gh-move-many');
//                GH.Util.show("gh-move-count");
//	        }
//        }
//        else{
//            this.board.unselect(true);
//            this.select();
//        }
//
//        GH.Util.addClassName(this.cKey, 'gh-move-main');
//
//        if (this.isInListView() && Boards.isPlanningBoard() && !Boards.inSearchMode) {
//        	// adjust the position since the list view shortens the line. The min-width keeps the layout
//        	// intact when dragging from the right end.
//        	// GHS-3117:
//        	//var leftPadding = event.pointerX() - 40;
//        	var leftPadding = event.clientX - 40;
//        	if (leftPadding < 0) leftPadding = 0;
//            AJS.$('#' + this.cKey).css({
//            	'padding-left' : leftPadding,
//            	'min-width' : AJS.$('#' + this.cKey + " .gh-subhead").outerWidth() + 10
//            });
//        }
//    },
//    cardStopped:function(){
//		if(Prototype.Browser.IE){ document.onselectstart = function() {return true;}; }
//
//        Boards.draggedIssue = null;
//        GH.Util.removeClassName(this.cKey, 'gh-move-main');
//        GH.Util.removeClassName(this.cKey, 'gh-move-many');
//        GH.Util.hide("gh-move-count");
//
//        this.board.selectedIssues.values().each(function(issue){
//        	GH.Util.removeClassName(issue.cKey, 'gh-move-other');
//        });
//
//        if (this.isInListView() && Boards.isPlanningBoard() && !Boards.inSearchMode) {
//        	AJS.$('#' + this.cKey).css({
//        		'padding-left' : '',
//        		'min-width' : ''
//        	});
//        }
//    },
	activate:function(){
    	this.board.notifyPage(true);
    	if(!Boards.draggedIssue){
        	GH.Util.addClassName(this.cKey, 'gh-target-hover');
    	}
    	else{
			if(Boards.draggedIssue.index - this.index == -1){
				return this.hover();
			}
			else if(Boards.draggedIssue.index < this.index){ 
				if(this.parentKey != Boards.draggedIssue.parentKey){
					if(this.isSubtask()){
						return this.hover();
					}
					else{
						var perviousIssue = this.board.getIssueAt(this.index - 1);
						if(!perviousIssue || perviousIssue.parentKey != Boards.draggedIssue.parentKey){
							return this.hover();
						}
					}
				}
				else{
					var perviousIssue = this.board.getIssueAt(this.index - 1);
					if(perviousIssue && perviousIssue.parentKey == Boards.draggedIssue.key){
						return this.hover();
					}
				}
			}
			else if(this.parentKey != Boards.draggedIssue.parentKey){
				return this.hover();
			}
			
			$(this.cKey).style.paddingTop = Boards.ISSUE_PADDING + 'px';
    	}
	},
	cardDropped:function(element, EoF){
		if(Boards.draggedMarker){ // Case where the marker was the dragged element
			Boards.getMarker(element.id.split("marker_")[1]).forcePosition(this);
		}
		else{ // The dragged element is an Issue
			var action = 'Rank';
			var baseIssue = this;
			if(Boards.draggedIssue.isSubtask()){
				if(Boards.draggedIssue.parentKey == baseIssue.key){
					return;
				}
				else if(baseIssue.isSubtask()){
					if(Boards.draggedIssue.parentKey != baseIssue.parentKey){
						action = 'Moving';
						baseIssue =  baseIssue.getParent();
					}
					else{
						if(!EoF && Boards.isListView() && Boards.draggedIssue.index - baseIssue.index < -1){
							baseIssue = baseIssue.board.getIssueAt(baseIssue.index-1);
						}
					}
				}
				else{
					var shifted = !EoF && Boards.isListView() && Boards.draggedIssue.index - baseIssue.index < -1;
					if(shifted){
						baseIssue = baseIssue.board.getIssueAt(baseIssue.index-1);
					}
					if(!baseIssue.isSubtask() || Boards.draggedIssue.parentKey != baseIssue.parentKey){
						action = 'Moving';
						if(shifted){
							var tempIssue = baseIssue.board.getIssueAt(baseIssue.index+1);
							baseIssue =  tempIssue.isSubtask() ? baseIssue : tempIssue; //unshift
						}
					}
				}
			}
			else{
				if(!EoF && Boards.isListView() && Boards.draggedIssue.index - baseIssue.index < -1){
					baseIssue = baseIssue.board.getIssueAt(baseIssue.index-1);
				}
				baseIssue = baseIssue.isSubtask() ? baseIssue.getParent() : baseIssue;
			}
			if(!baseIssue || baseIssue.isSelected()) return;
			if(action == 'Rank'){
				AJS.$("div.js-mkr").each(function(index, marker){
					if(EoF || Boards.draggedIssue.key == $(marker.id).readAttribute("position")){
						$(marker.id).setAttribute('position', '');
					}
				});
			}
			var start = '';
			if(this.board instanceof Page){
				start = this.board.getStart();
				this.board.hide();
			}
			Boards.updater('confirmation', action, $H({id:baseIssue.id, issueKeys: Boards.focussedBoard().selectedIssuesQueryString(), start:Boards.mainBoard.getStart(), pageRankStart:start}), true, Boards.doneWorking);
		}
	},
	deactivate:function(){
    	this.board.notifyPage(false);
		$(this.cKey).style.paddingTop='';
		this.unhover();
	},
	/* This function ensures that the issue is visible before selecting it (which might not be the case for hidden subtasks */
	doSelect:function(anchored){
		this.cancelEdit();
		if(this.isSubtask() && !Boards.inSearchMode){
			if(Boards.isPlanningBoard() || Boards.isCompactView()){
				if(GH.Util.hasClassName('colapse_' + this.parentKey, 'gh-close')){
					this.getParent().expandSubs();
				}
			}
			else if($('colapse_' + this.parentKey)){
				Boards.mainBoard.getIssue(this.parentKey).expandSubs();
			}
		}
		GH.Util.show(this.cKey);
		
		this.select(anchored);
	},
    isSelectable:function(){
    	if(!this.selectable) return false;
    	return this.board.selectedIssues.size() == 0 || this.board.selectedIssues.values()[0].parentKey == this.parentKey;
    },
	select:function(anchored){
		if(this.isSelectable()){
			if (! this.isSelected()) {
				GH.Util.addClassName(this.cKey, 'gh-select');
				this.board.selectedIssues.set(this.key, this);
			}
			if (anchored) {
				var $issue = AJS.$('#'+this.cKey);
				// keep a margin of one card height
				var issueHeight = $issue.height() + 10;
				var options = {
					marginBottom: issueHeight,
					marginTo: issueHeight
				};
				$issue.scrollIntoView(options);
			}
			return true;
		}
		return false;
	},
	unselect:function(){
		if(this.board.selectedIssues.unset(this.key)){
			GH.Util.removeClassName(this.cKey, 'gh-select');
		}
	},
	isSelected:function(){
		return this.board.selectedIssues.get(this.key) != null;
	},
	hover:function(){
		if(Boards.draggedIssue && Boards.draggedIssue.isSubtask() && Boards.draggedIssue.parentKey != this.key && Boards.draggedIssue.parentKey != this.parentKey){
			if(this.isSubtask() && this.getParent()){
				GH.Util.addClassName(this.getParent().cKey, 'gh-target-hover');
			}
			else{
				GH.Util.addClassName(this.cKey, 'gh-target-hover');
			}
		}
	},
	unhover:function(){
		if(this.isSubtask() && this.getParent()){
			GH.Util.removeClassName(this.getParent().cKey, 'gh-target-hover');
		}
		GH.Util.removeClassName(this.cKey, 'gh-target-hover');
	},
	multiSelect:function(e){
		if(!Boards.isTaskBoard() && GH.Util.isSelectionModifier(e)){ 
			if(!this.isSelected()){
				this.board.unselect(false);
				this.select();
			}
			else{ 
				this.unselect(); 
			}
		}
		else if(!Boards.isTaskBoard() && e.shiftKey){
		  // IE selects text when using shift - unselect whatever has been selected immediately
			if(Prototype.Browser.IE){
				Boards.clearTextSelections();
			}
			var firstIssue; var lastIssue;
			var sortedIssues  = this.board.issues.values().sortBy(function(issue) { return issue.index; });
			
			if(this.board.selectedIssues.size() > 0){
				var sortedSelectedIssues  = this.board.selectedIssues.values().sortBy(function(issue) { return issue.index; });
				firstIssue = sortedSelectedIssues[0];
				lastIssue = sortedSelectedIssues[sortedSelectedIssues.size() - 1];
			}
			else{
				sortedIssues.each(function(anIssue){
					if(anIssue.isSelected()){
						firstIssue = !firstIssue ? anIssue : firstIssue;
						lastIssue = anIssue;
					}
				});
			}
			
			if(!firstIssue){
				this.board.unselect(false);
				this.selectIssues(sortedIssues[0], sortedIssues, !this.isSelected());
			}
			else if(firstIssue.index == this.index || lastIssue.index == this.index){
				this.unselect();
			}
			else if(!lastIssue || firstIssue.index > this.index){
				this.board.unselect(false);
				this.selectIssues(firstIssue, sortedIssues, !this.isSelected());
			}
			else if(lastIssue.index < this.index){
				this.board.unselect(false);
				this.selectIssues(lastIssue, sortedIssues, !this.isSelected());
			}
			else{
				this.board.unselect(false);
				this.selectIssues(firstIssue.index - this.index > this.index - lastIssue.index ? firstIssue : lastIssue, sortedIssues, !this.isSelected());
			}
		}
		else{
			this.board.unselect(true, this.key);
			this.select();
		}
	},
	selectIssues:function(baseIssue, sortedIssues, doSelect){
		var start = Math.min(baseIssue.index, this.index);
		var end = Math.max(baseIssue.index, this.index);
		sortedIssues.each(function(anIssue){
			if(anIssue.index >= start && anIssue.index <= end){
				doSelect ? anIssue.select() : anIssue.unselect();
			}
			else if(anIssue.index > end){
				throw $break;
			}
		});
	},
	refresh:function(searchKey, subtasks){
		this.board.unselect(true);
		this.issueUpdater((Boards.isTaskBoard()?"TB":"")+"RefreshIssue", $H({id:this.id, stepId:this.board.id}), this.cKey);
		this.refreshParent();
	},
	refreshParent:function(){
	    if(!Boards.is('TaskBoard') && $('gh-issue_' + this.board.id + "_" + this.parentKey)){
            this.getParent().issueUpdater("RefreshIssue", $H({id:this.getParent().id, stepId:this.board.id}), this.getParent().cKey);
        }
	},
	equals:function(issue){
		return this.key == issue.key;
	},
	clear:function(){
		this.disableAll();
		this.parentIssue = null;
		this.board = null;
	}
};
function getIssue(bId,iKey){ return Boards.getBoard(bId).getIssue(iKey); }

/**
 * finds the first issue on the current view that has the key. This does not work for inline popup dialogs,
 * since they may show the same issue several times. 
 */
function findIssueByKey(issueKey) {
	var issue = null;
	if (Boards.inSearchMode) {
		Boards.getBoard(10).issues.values().each(function(i){
			if (i.key == issueKey) {
				issue = i;
				throw $break;
			}
		});
		if (issue !== null) return issue;
	}
	Boards.boards.values().each(function(board){
		board.issues.values().each(function(i){
			if (i.key == issueKey) {
				issue = i;
				throw $break;
			}
		});
		if (issue !== null) throw $break;
	});
	return issue;
}

/**
 * finds all issues on the current view that have the key. Use in cases where inline popup dialogs are involved.
 */
function findIssuesByKey(issueKey) {
	var issues = [];
	Boards.boards.values().each(function(board){
		board.issues.values().each(function(i){
			if (i.key == issueKey) {
				issues[issues.length] = i;
				throw $break;
			}
		});
	});
	return issues;
}

var Ranking = new function()
{
	var relativeIssue;
	this.getPage=function(ctx, projectId, issueId, cfId, start, rankVMID, parentKey){
		var params = $H({fieldId:cfId, start:start});
		if($('ctx_'+cfId)) params = params.merge({contextName:$F('ctx_'+cfId)});
		//if($('newField_fixVersions'))params = params.merge({versionId:$F('newField_fixVersions')});
		// add backlog field value
		if(AJS.$('#gh-backlog-field-id').size() > 0){
        	var backlogFieldId = AJS.$('#gh-backlog-field-id').text();
        	if(AJS.$('#newField_'+backlogFieldId).size() > 0){
        		var backlogId = AJS.$('#newField_'+backlogFieldId).val();
        		params = params.merge({backlogId:backlogId});
            }
        }
		if($('newField_fixVersions'))params = params.merge({versionId:$F('newField_fixVersions')});
		if(parentKey)params = params.merge({parentKey:parentKey});
		params = params.merge({rankVMID:rankVMID});
		new Boards.updater('RankPage_'+cfId+rankVMID, "GetRankPage", params, true, Boards.success);
	};
	this.setRank=function(ctx, issueId, cfId, relIssue, absPos, relPos, rankVMID){
		GH.Util.switchView('RankPage_'+cfId+'Edit'+rankVMID, 'RankPage_'+cfId+'Close'+rankVMID);
		GH.Util.write('RankPage_'+cfId+rankVMID,'');
		GH.Util.write('RankValue_'+cfId+rankVMID, absPos);
		GH.Util.setValue(cfId, relPos);
		GH.Util.setValue('newField_'+cfId, relPos);
		Ranking.relativeIssue = relIssue;
	};
	this.closeRank=function(cfId, rankVMID){
		GH.Util.switchView('RankPage_'+cfId+'Edit'+rankVMID, 'RankPage_'+cfId+'Close'+rankVMID);
		GH.Util.write('RankPage_'+cfId+rankVMID,'');
	};
};

/**
 * Prevent click events that happen after drag/drop to fire the underlying actions.
 * Works on links and stuff with inline (traditional) onclick-events, and probably
 * even with registered event listeners, since the traditional onclick should come
 * first in the chain and consume the event.
 */
GH.CardDragClickHandler = {
	strip: function(element) {
		this.element = element;
		this.oldOnclick = element.onclick;
		element.onclick = this.handleClick;
	},
	handleClick: function(event) {
		var h = GH.CardDragClickHandler;
		h.element.onclick = h.oldOnclick;
		
		// IE doesn't pass the event object on in this setup, even if documented otherwise on MSDN.
		if (!event) event = window.event;
		// no one else should know this ever happened.
		var ev = AJS.$.Event(event);
		ev.stopImmediatePropagation();
		ev.stopPropagation();
		
		// IE special serving again, stop the default action from executing
		event.returnValue = false;
		
		// this prevents the click from being propagated to links. At least in non-IE-browsers.
		return false;
	}
}

/**
 * This is a bridge so that all AJS.popup's do in fact use AJS.flexipopup
 */
AJS.popup = function (options, width, id) {

    // for backwards-compatibility
    if (typeof options !== "object") {
        options = {
            width: arguments[0],
            height: arguments[1],
            id: arguments[2]
        };
    }

    var popup = new AJS.FlexiPopup({
        type: "blank",
        id: options.id || id,
        width: options.width,
        cached: true
    });
    
    /**
     * GH Customization: The escape key is proxying to the handleCancel function, which in turn calls hide().
     * In our case we want to call closePopup instead, to make sure we correctly cleanup internal state, plus
     * some popups need to do additional cleanup work after a popup has been canceled.
     */
    popup.handleCancel = function() {
    	if (AJS.FlexiPopup.current === this) {
    		bridge.handleCancel();
    	}
    }

    var bridge = {
    	
    	handleCancel: function() {
    		popup.hide();
    	},
    	
        element: popup.get$popup(),

        show: function () {
            popup.show();
        },
        hide: function () {
            popup.hide();
        },
        changeSize: function () {
            popup._positionInCenter();
        },

        remove: function () {
            this.element.remove();
            this.element = null;
        },

        /**
         * Not supported in bridge
         * @method disable
        */
        disable: function() {},

        /**
         * Not supported in bridge
         * @method enable
        */
        enable: function() {}
    };
    return bridge;
};

GH.IE7 = {};
GH.IE7.zIndexCache = {};

