/**
 * Functions here cover the modification through configuration or overriding of JIRA's JavaScript elements.
 */

GH.jiramod = {
	run: function() {
		this.modifySetFocus();
	},
	
	/**
	 * Override expensive CSS selector calls, since we're not using that function, but it
	 * gets called by JIRA on document ready. Basically, we're providing a no-op configuration
	 * on the stack that gets called on page load. This way, things like dialogs that we actually
	 * use can still make use of the focusing.
	 */
	modifySetFocus: function() {
		var noopConf = new jira.setFocus.FocusConfiguration();
		noopConf.focusNow = function(){};
		jira.setFocus.pushConfiguration(noopConf);		
	}
};
GH.jiramod.run();


/**
 * Override Issue key/id discovery methods (used by issue actions popup (and probably other code as well) 
 */
JIRA.IssueNavigator.getSelectedIssueKey = function() {
	var issue = Boards.firstSelectedIssue();
	if (issue) {
		return issue.key;
	}
};
JIRA.IssueNavigator.getSelectedIssueId = function() {
	var issue = Boards.firstSelectedIssue();
	if (issue) {
		return issue.id;
	}
}
JIRA.Issue.getIssueId = JIRA.IssueNavigator.getSelectedIssueId;
JIRA.Issue.getIssueKey = JIRA.IssueNavigator.getSelectedIssueKey;
