/**
 * Defines functions called by the keyboard-shortcut modules.
 */
GH.Shortcut = {
	focusBoardSearch: function() {
		Boards.focusBoardSearch();
	},
	newIssue: function() {
		Boards.createNewIssue();
	},
	nextBox: function() {
		Boards.selectNextBox();
	},
	previousBox: function() {
		Boards.selectPreviousBox();
	},
	toggleBox: function() {
		Boards.toggleSelectedBox();
	},
	toggleIssue: function() {
		Boards.toggleSelectedCard();
	},
	editIssuePriority: function() {
		Boards.editSelectedIssuePriority();
	},
	deleteIssue: function() {
		Boards.deleteSelectedIssue();
	},
	nextIssue: function() {
		Boards.selectNextIssue(true);
	},
	previousIssue: function() {
		Boards.selectPreviousIssue(true);
	},
	viewIssue: function() {
		Boards.viewSelectedIssue();
	},
	editIssue: function() {
		Boards.editSelectedIssue();
	},
	assignIssue: function() {
		Boards.assignSelectedIssue();
	},
	commentIssue: function() {
		Boards.commentSelectedIssue();
	},
	editIssueLabels: function() {
		Boards.editSelectedIssueLabels();
	},
	showOperationsDialog: function() {
		Boards.showActionsDialog();
	},
	rightColumnToggle: function() {
		AJS.$('#gh-column a.js-columnToggle').click();
	},
    projector: function() {
        GH.Projector.toggleUI();
	},
    sendToTop: function() {

	},
    sendToBottom: function() {

	}
};

/**
 * Handles the return key, which should act like the o key (view issue)/ 
 */
AJS.$(document).keydown(function(e){
    if (e.keyCode == '13'){
        var target = e.target;
        // On different browser the originalTarget is different, but all of these are impossible for a user to trigger.
        if (target === undefined || target.nodeName === "HTML" || target.nodeName === "BODY" || target == document){
        	Boards.viewSelectedIssue();
        }
    }
});
