// google analytics tracking code - provided by google

var _gaq = _gaq || [];
_gaq.push(['greenhopper._setAccount', 'UA-20272869-4']);
_gaq.push(['greenhopper._setDomainName', "none"]);
_gaq.push(['greenhopper._setAllowLinker', true]);
_gaq.push(['greenhopper._trackPageview']);

// if _gat is undefined, then we don't yet have an instance of GA on the page, so we need to load it.
if(typeof _gat === "undefined") {
    (function() {
        var ga = document.createElement('script');
        ga.type = 'text/javascript';
        ga.async = true;
        ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
        var s = document.getElementsByTagName('script')[0];
        s.parentNode.insertBefore(ga, s);
    })();
}

// end of google provided code

// events we are going to send to google analytics, this is done regardless of whether _gat was defined above
(function () {

    // abstraction layer over GA
    function trackEvent(category, action, label) {
        _gaq.push(['greenhopper._trackEvent', category, action, label]);
    }

    // swimlane events
    AJS.$(AJS).bind("gh.swimlane.create", function(e, params) {
        trackEvent("gh.swimlane.create", params.jql, "");
    }).bind("gh.swimlane.edit", function(e, params) {
        trackEvent("gh.swimlane.edit", params.newJql, params.oldJql);
    }).bind("gh.swimlane.delete", function(e, params) {
        trackEvent("gh.swimlane.delete", params.jql, "");
    })
    // quick filter events
    .bind("gh.quickfilter.create", function(e, params) {
        trackEvent("gh.quickfilter.create", params.jql, "");
    }).bind("gh.quickfilter.edit", function(e, params) {
        trackEvent("gh.quickfilter.edit", params.newJql, params.oldJql);
    }).bind("gh.quickfilter.delete", function(e, params) {
        trackEvent("gh.quickfilter.delete", params.jql, "");
    })
    // chart intro clickthrough
    .bind("gh.chartintro.clickthrough", function(e, params) {
        trackEvent("gh.chartintro.clickthrough", params.chartType, "")
    })
    // virtual pageviews should fire trackPageview events
    .bind("gh.virtualpageview", function(e) {
        _gaq.push(['greenhopper._trackPageview']);
    })
    // track inline edit updates
    .bind("gh.issuedetail.inlineedit", function(e, params) {
        trackEvent("gh.issuedetail.inlineedit", params.fieldId, "");
    })
    // track release events. event names are discrete, but event categories are common, this is to make better use of
    // GA API. We can do this here because we don't need to send stupid amounts of data like with the QF/SL events
    .bind("gh.release.start", function(e) {
        trackEvent("gh.release", "start", "");
    })
    .bind("gh.release.complete", function(e, params) {
        trackEvent("gh.release", "complete", params.count);
    })
    .bind("gh.release.cancel", function(e) {
        trackEvent("gh.release", "cancel", "");
    })
    // welcome mat dialog change event. Tracks Start, cancel and complete events for
    .bind("gh.welcome.dialog.change", function(e, params) {
        trackEvent(params.category, params.action, params.label);
    })
    // ranking issues (either via mouse or keyboard shortcut)
    .bind("gh.rapidboard.rankissues", function(e, params) {
        trackEvent("gh.rapidboard.rankissues", params.action, params.label);
    });

})();
