/**
 * Holds the code for the rapid view delete dialog
 */
GH.RapidBoard.DeleteDialog = {};

/**
 * Renders the create rapidview dialog given the create model
 */
GH.RapidBoard.DeleteDialog.showDeleteDialog = function(rapidViewId, rapidViewName) {
    var dlg = new AJS.Dialog({
        width : 500,
        height : 300,
        id : 'ghx-rapidview-delete'
    });
    AJS.$('#'+dlg.id).addClass('ghx-dialog');
    dlg.addHeader(AJS.I18n.getText('gh.rapid.view.delete'));
    dlg.addPanel('', 'panel');
    dlg.getCurrentPanel().html(AJS.I18n.getText('gh.rapid.view.delete.confirm', soy.$$escapeHtml(rapidViewName)));
    dlg.addSubmit(
    	AJS.I18n.getText('gh.rapid.operations.delete'),
    	function() {
            dlg.remove();
            GH.RapidBoard.DeleteDialog.doDelete(rapidViewId, rapidViewName);
        }
    );
    dlg.addCancel(AJS.I18n.getText('gh.rapid.view.create.cancel'), function() {
        dlg.remove();
    });
    
    dlg.show();	
};

/**
 * Submits the dialog data
 */
GH.RapidBoard.DeleteDialog.doDelete = function(rapidViewId, rapidViewName) {
    GH.Ajax.del({
        url : GH.Ajax.buildRestUrl('/rapidview/'+rapidViewId),
        success : function(result) {
            GH.RapidBoard.DeleteDialog.handleSuccess(rapidViewId, rapidViewName);
        }
    });
};

GH.RapidBoard.DeleteDialog.handleSuccess = function(rapidViewId, rapidViewName) {
    GH.Message.showSuccess(AJS.I18n.getText('gh.rapid.view.delete.success', soy.$$escapeHtml(rapidViewName)));
    AJS.$(document).trigger('ghx.rapidview.deleted', {
        rapidViewId: rapidViewId,
        rapidViewName: rapidViewName
    });
};
