GH.RapidBoard.ManageViews = {};

GH.RapidBoard.ManageViews.init = function() {
	// load the model
	GH.RapidBoard.ManageViews.loadModel();

    // assign delete RapidView button
    AJS.$(document).delegate('.ghx-delete-view', 'click', function(event){
        var rapidViewId = AJS.$(this).attr('data-view-id');
        var rapidViewName = AJS.$(this).attr('data-view-name');
    	GH.RapidBoard.DeleteDialog.showDeleteDialog(rapidViewId, rapidViewName);
    });

    // handle rapid view deleted event
    AJS.$(document).bind('ghx.rapidview.deleted', GH.RapidBoard.ManageViews.loadModel);

    // create dialog
    GH.RapidBoard.CreateDialog.init();
};

/**
 * Calls the rapid board data rest service.
 */
GH.RapidBoard.ManageViews.loadModel = function() {
    GH.Ajax.get({
        url: GH.Ajax.buildRestUrl('/rapidviews/list.json'),
        success: GH.RapidBoard.ManageViews.render
    });
};

/**
 * Renders the complete edit screen 
 */
GH.RapidBoard.ManageViews.render = function(model) {

    var canCreateView = GH.Global.username ? true : false;

    // render hero actions
    AJS.$('#ghx-header').append(GH.tpl.rapid.manageviews.renderHero({ canCreateView:canCreateView }));

    // render the header html
    if (model.views.length > 0) {
        model.views.sort(GH.RapidBoard.RapidViewSelector.viewModelComparator);
        AJS.$('#ghx-content-main').html(GH.tpl.rapid.manageviews.renderViewsTable({ views: model.views, canCreateView:canCreateView }));
    } else {
        AJS.$('#ghx-content-main').html(GH.tpl.board.x.renderNoViews());
    }
};
