AJS.$(function() {
    var buildInfo = AJS.$("#footer-build-information").text(),
    //hit Alt + Enter on this string in Intellij and select "Edit HTML fragment" to edit it!
    formTemplate = "<form action=\"{baseurl}/rest/greenhopper/1.0/provide/{timestamp}\" id=\"ghx-feedback-form\" method=\"post\" class=\"aui\">\n    <div class=\"content-body\">\n        <p>{feedbackHelp}</p>\n        <p>{privacy}</p>\n\n        <div id=\"desc-group\" class=\"field-group\">\n            <label for=\"description\">{descriptionLabel}<span class=\"aui-icon icon-required\"></span></label><textarea class=\"textarea long-field\" id=\"description\" name=\"description\"></textarea>\n        </div>\n        <div id=\"screenshot-group\" class=\"field-group\">\n            <label for=\"screenshot\">{screenshotLabel}</label><input type=\"file\" name=\"screenshot\" class=\"file\" id=\"screenshot\">\n        </div>\n        <div id=\"name-group\" class=\"field-group\">\n            <label for=\"fullname\">{nameLabel}</label><input type=\"text\" name=\"fullname\" class=\"text\" id=\"fullname\"></div>\n        <div id=\"email-group\" class=\"field-group\">\n            <label for=\"email\">{emailLabel}</label><input type=\"text\" name=\"email\" class=\"text\" id=\"email\">\n            <div class=\"description\">{emailDescription}</div>\n        </div>\n        <input type=\"hidden\" name=\"version\" id=\"version\" value=\"{version}\">\n        <input type=\"hidden\" name=\"location\" id=\"location\" value=\"{windowLocation}\">\n        <input type=\"hidden\" name=\"userAgent\" id=\"userAgent\" value=\"{userAgent}\">        \n    </div>\n</form>",

    getFilename = function(fileName) {
        if(AJS.$.browser.msie && fileName.indexOf("\\") >= 0) {
            //IE returns an absolute path for the selected file, we however only want to display the
            //filename.
            fileName = fileName.substring(fileName.lastIndexOf("\\") + 1);
        }
        return fileName;
    },

    addFormThrobber = function() {
        AJS.$("#ghx-feedback-dialog .dialog-button-panel").addClass("loading throbber");
        AJS.$("#ghx-feedback-dialog .submit-button").attr("disabled", "true");
    },

    cleanupAfterSubmit = function(removeSubmitButton) {
        if(removeSubmitButton) {
            AJS.$("#ghx-feedback-dialog").find(".submit-button").remove();
        } else {
            AJS.$("#ghx-feedback-dialog").find(".submit-button").removeAttr("disabled");
        }
        AJS.$("#ghx-feedback-dialog .dialog-button-panel").removeClass("loading").removeClass("throbber");
    },

    renderAttachFileForm = function(timestamp) {
        return AJS.$("<form method='post' enctype='multipart/form-data' action='" + contextPath + "/rest/greenhopper/1.0/provide/" + timestamp + "'/>").hide();
    },

    setupDialog = function(timestamp) {
        AJS.$("#ghx-feedback-form").remove();

        var $formTemplate = AJS.template(formTemplate);
        var data = {
            baseurl: contextPath,
            timestamp: timestamp,
            feedbackHelp: AJS.I18n.getText("gh.feedback.form.help.line1"),
            descriptionLabel: AJS.I18n.getText("gh.feedback.form.description"),
            screenshotLabel: AJS.I18n.getText("gh.feedback.form.attachment"),
            nameLabel: AJS.I18n.getText("gh.feedback.form.fullname"),
            emailLabel: AJS.I18n.getText("gh.feedback.form.email"),
            emailDescription: AJS.I18n.getText("gh.feedback.form.help.line2"),
            version: buildInfo.substr(1, buildInfo.length-2),
            windowLocation: window.location,
            userAgent: navigator.userAgent,
            privacy: AJS.I18n.getText("gh.feedback.form.help.privacy")
        };

        return $formTemplate.fill(data).toString();
    };

    var $feedbackLink = AJS.$("<a class=\"ghx-feedback-link ghx-spch-bub-inside\" href=\"#\">" +
            "<span class=\"point\"></span>" +
            "<em>" + AJS.I18n.getText("gh.feedback.form.trigger.text") + "</em></a>");

    AJS.$("#header-top").append($feedbackLink);

    var submitForm = function(dialog) {
        var $form = AJS.$("#ghx-feedback-form");
        var desc = $form.find("#description").val();
        if(!desc || desc.length == 0) {
            alert(AJS.I18n.getText("gh.feedback.form.error"));
            return;
        }
        $form.ajaxForm({
            //set the timeout to infinity since it could take a long time to upload large files (JRADEV-3455)
            timeout:0,
            beforeSubmit: function () {
                addFormThrobber();
            },
            success: function() {
                $form.parent().html('<div class="content-body"><p>' + AJS.I18n.getText("gh.feedback.dialog.thanks") + "</p></div>");
                cleanupAfterSubmit(true);
            },
            error: function() {
                $form.parent().html('<div class="content-body"><p>' + AJS.I18n.getText("gh.feedback.dialog.thanks") + "</p></div>");
                cleanupAfterSubmit(true);
            }
        });
        $form.submit();
    };

    $feedbackLink.click(function(e) {
        e.preventDefault();

        AJS.$("#ghx-feedback-dialog").remove();
        var timestamp = new Date().getTime();
        var dialog=new AJS.Dialog({width:690, height:515, id:"ghx-feedback-dialog"});

        dialog.addHeader(AJS.I18n.getText("gh.feedback.dialog.title"));
        dialog.addPanel("Panel 1", setupDialog(timestamp), "panel-body");
        dialog.addButton(AJS.I18n.getText("gh.feedback.form.submit"), submitForm, "submit-button");
        dialog.addLink(AJS.I18n.getText("gh.feedback.form.close"), function(dialog){ dialog.remove() });
        //file attachment behaviour
        AJS.$("#screenshot").change(function(e) {
            var $form = renderAttachFileForm(timestamp);
            var $input = AJS.$(this);
            $form.append($input);
            AJS.$("body").append($form);

            $form.ajaxForm({
                //set the timeout to infinity since it could take a long time to upload large files (JRADEV-3455)
                timeout:0,
                cleanupAfterSubmit: function() {
                    cleanupAfterSubmit(false);
                    $form.remove();
                },
                beforeSubmit: function () {
                    addFormThrobber();
                    AJS.$("#screenshot-group").append(getFilename($input.val()));
                },
                error: function (xhr) {
                    cleanupAfterSubmit(false);
                    $form.remove();
                },
                success: function (response) {
                    cleanupAfterSubmit(false);
                    $form.remove();
                }
            });
            $form.submit();
        });

        dialog.show();
    });
});
