/**
 * Extension to FormDialog.
 * 
 * Customizes success and failure handler
 */
GH.Dialog.XBoardExtension = {};
GH.Dialog.XBoardExtension.handleSuccess = function() {
	// hide the dialog
	this.hide(true, true);
	
	// ensure the spinner is hidden
	this._hideloadingIndicator();
	
	// fetch the issue we just changed. Do this before reloading as the selected issue might not be there anymore
	var issueId = GH.RapidBoard.Issue.getSelectedIssueId();
	
	// Reload
	GH.RapidBoard.reload();

	// show the update message
	GH.Message.showIssueMessage(issueId);
};

/** Called when the form has been canceled. */
GH.Dialog.XBoardExtension.doCancelCleanup = function() {
};
