/**
 * Instantiates jql autocomplete functionality on request instead of on page load.
 * 
 * Required data is not stored in the dom, but provided as a resource included in the page.
 */

/** These variables are set by a separate resource. Just ensure they are not undefined. */
if (typeof GH.JQLAutoComplete.jqlFieldz == 'undefined') { GH.JQLAutoComplete.jqlFieldz = []; }
if (typeof GH.JQLAutoComplete.jqlFunctionNamez == 'undefined') { GH.JQLAutoComplete.jqlFieldz = []; }
if (typeof GH.JQLAutoComplete.jqlReservedWordz == 'undefined') { GH.JQLAutoComplete.jqlFieldz = []; }

/**
 * Initializes an auto complete field
 */
GH.JQLAutoComplete.initialize = function(fieldID, errorID) {

	/*jQuery.expr[':'].focus = function( elem ) {
	  return elem === document.activeElement && ( elem.type || elem.href );
	};*/
	
	var field = AJS.$('#'+fieldID);
	var hasFocus = field.length > 0 && field[0] == document.activeElement;
	
    //restore('jqlHistory');

	// unlike JIRA, we should already have the values in javascript variables
    /*
    var jqlFieldNames = JSON.parse(jQuery("#jqlFieldz").text());
    var jqlFunctionNames = JSON.parse(jQuery("#jqlFunctionNamez").text());
    var jqlReservedWords = JSON.parse(jQuery("#jqlReservedWordz").text());
    */
	var jqlFieldNames = GH.JQLAutoComplete.jqlFieldz;
	var jqlFunctionNames = GH.JQLAutoComplete.jqlFunctionNamez;
	var jqlReservedWords = GH.JQLAutoComplete.jqlReservedWordz;

    var jqlAutoComplete = JIRA.JQLAutoComplete({
        fieldID: fieldID, //'jqltext',
        parser: JIRA.JQLAutoComplete.MyParser(jqlReservedWords),
        queryDelay: .65,
        jqlFieldNames: jqlFieldNames,
        jqlFunctionNames: jqlFunctionNames,
        minQueryLength: 0,
        allowArrowCarousel: true,
        autoSelectFirst: false,
        errorID: errorID //'jqlerrormsg'
    });

    var jQueryRef = jQuery('#'+fieldID); //'#jqltext');

    // ensure we don't submit anything
    jQueryRef.unbind("keypress", submitOnEnter)/*.keypress(
            function (e) {
                if (jqlAutoComplete.dropdownController === null || !jqlAutoComplete.dropdownController.displayed || jqlAutoComplete.selectedIndex < 0) {
                    if (e.keyCode == 13 && !e.ctrlKey && ! e.shiftKey)
                    {
                        jQuery('#jqlform').submit();
                        return false;
                    }
                    else
                    {
                        return true;
                    }
                }
            })*/;
    jqlAutoComplete.buildResponseContainer();
    jqlAutoComplete.parse(jQueryRef.text());
    jqlAutoComplete.updateColumnLineCount();

    jQueryRef.click(function(){
        jqlAutoComplete.dropdownController.hideDropdown();
    });
    
    if (hasFocus) {
    	field.select();
    }
};
