GH.RapidBoard.QuickFilterView = {};

GH.RapidBoard.QuickFilterView.toggleQuickFilter = function(event) {
	var button = AJS.$(this);
	var quickFilterId = parseInt(button.attr('data-filter-id'));
    
    //Get the number encoded after the final dash in the button's id.
    GH.RapidBoard.QuickFilterView.toggleActiveQuickFilter(quickFilterId);
    
    button.toggleClass("active");
    
    // load the board again
    // TODO: this should happen through an event!
    GH.RapidBoard.loadBoardData();
};

/**
 * Toggles a quick filter
 */
GH.RapidBoard.QuickFilterView.toggleActiveQuickFilter = function (quickFilterId) {
	// fetch the currently active quick filters
    if (quickFilterId) {
        var found = false;
        
        var activeFilters = GH.RapidBoard.State.getActiveQuickFilters();
        
        for (var i = 0, l = activeFilters.length; i < l; i++) {
            if (activeFilters[i] == quickFilterId) {
                activeFilters.splice(i, 1);
                found = true;
                break;
            }
        }
        if (!found) {
            activeFilters.push(quickFilterId);
        }
        
        // set the new values
        GH.RapidBoard.State.setActiveQuickFilters(activeFilters);
        GH.RapidBoard.State.pushState();
    }    
};

GH.RapidBoard.QuickFilterView.init = function() {
    AJS.$(document).delegate('.ghx-quickfilter-button', 'click', GH.RapidBoard.QuickFilterView.toggleQuickFilter);
};
