/**
 * Chart view component.
 *
 * Loads chart data, then passes contorl to chart implementation for actual rendering
 */
GH.ChartIntro = {};

/**
 * Returns whether the intro should be displayed
 */
GH.ChartIntro.shouldShowIntro = function() {
	return GH.RapidBoard.State.getChartIntro();
};


/**
 * Loads the chart intro
 */
GH.ChartIntro.openIntro = function() {
    GH.RapidBoard.State.setChartIntro(true);
    GH.RapidBoard.State.pushState();

    // hide timeframe buttons
    AJS.$(".ghx-timeframe").hide();

    // Render Chart Structure
    AJS.$('#ghx-display').addClass('ghx-chart').html(GH.tpl.rapid.chart.renderChartIntro({
        availableCharts: GH.RapidBoard.ChartView.getCharts()
    }));
    AJS.$(".chart-intro-button").bind('click', function(){
        // on clicking a button we remove the intro and open the corresponding chart view
        var $this = AJS.$(this);
        AJS.$('#ghx-display').removeClass('ghx-chart').empty();
        GH.RapidBoard.State.setChartIntro(false);

        GH.RapidBoard.ChartView.openChartView($this.data("chart"));

        // if this is the first time that user has clicked through...
        if(!GH.RapidBoard.UserData.hasUserSeenChartIntro) {
            // update the userData setting
            GH.RapidBoard.UserData.hasUserSeenChartIntro = true;
            // if we have an user actual user then we should update on the server to prevent them seeing the intro again
            if(GH.RapidBoard.UserData.hasUser) {
                GH.Ajax.put({
                    url: GH.Ajax.buildRestUrl('/userData/seenChartIntro.json'),
                    data: { "hasSeen": true }
                });
            }
        }

        AJS.$(AJS).trigger("gh.chartintro.clickthrough", {
            chartType : $this.data("chart")
        });

    });
};
