/**
 * Holds the state for the welcome mat wizard. Also takes care of history-based navigation. 
 */
GH.Welcome.State = {};

// this is where all data lives
GH.Welcome.State.data = {};

/**
 * What type of Welcome Mat are we
 */
GH.Welcome.State.setWelcomeMatType = function(welcomeMatType) {
    GH.Welcome.State.data.welcomeMatType = welcomeMatType;
};

/**
 * Are there any existing rapid views visible to the current user
 */
GH.Welcome.State.setCanUserSearchForRapidViews = function(canUserSearchForRapidViews) {
    GH.Welcome.State.data.canUserSearchForRapidViews = canUserSearchForRapidViews;
};

/**
 * This is the page model with some upfront server info
 */
GH.Welcome.State.setModel = function(model) {
    GH.Welcome.State.data.model = model;
};

/**
 * Remember data the user entered for a project
 */
GH.Welcome.State.setProject = function(project) {
    GH.Welcome.State.data.project = project;
};

/**
 * Remember data the user entered for a project
 */
GH.Welcome.State.setView = function(view) {
    GH.Welcome.State.data.view = view;
};

/**
 * Transform the internal data into an object that gets serialised into JSON and then 
 * deserialised into  com.atlassian.greenhopper.web.rapid.welcome.WelcomeCreateProjectRequest
 */
GH.Welcome.State.getCreateProjectRequest = function() {
    return {
        projectName : GH.Welcome.State.data.project.name,
        projectKey : GH.Welcome.State.data.project.key,
        projectLeadUserName : GH.Welcome.State.data.project.lead
    };
};

/**
 * Transform the internal data into an object that gets serialised into JSON and then
 * deserialised into  com.atlassian.greenhopper.web.rapid.welcome.WelcomeCreateViewRequest
 */
GH.Welcome.State.getCreateViewRequest = function() {
    return GH.Welcome.State.data.view;
};
