AJS.test.require("com.atlassian.jira.jira-quick-edit-plugin:quick-form");
AJS.test.require("com.atlassian.jira.jira-quick-edit-plugin:test-util");
test("Construction does not go straight to server (lazy)",function(){assertInvocationNotToUseAjax("Expected construction of model not to use ajax, should be lazy",function(){new JIRA.Forms.Model({userFieldsResource:"http://www.example.com",fieldsResource:"http://www.example.com"})
})
});
test("refresh",function(){var C=new JIRA.Forms.Model({userFieldsResource:"http://www.example.com",fieldsResource:"http://www.example.com"});
var A=[{},{}],B=[{},{}],E={showWelcomeScreen:true};
expectSuccessfulAjax({fields:A,sortedTabs:B,userPreferences:E});
C.refresh();
equals(A,C.fields);
equals(B,C.sortedTabs);
equals(E,C.userPreferences);
var G=[{},{},{},{}],D=[{},{},{},{}],F={showWelcomeScreen:false};
expectSuccessfulAjax({fields:G,sortedTabs:D,userPreferences:F});
C.refresh();
equals(G,C.fields);
equals(D,C.sortedTabs);
equals(F,C.userPreferences)
});
test("retainValue",function(){var A=new JIRA.Forms.Model({userFieldsResource:"http://www.example.com",fieldsResource:"http://www.example.com"});
ok(!A.hasRetainFeature(),"Expected not to have retain feature by default");
raises(function(){A.addFieldToRetainValue()
});
raises(function(){A.removeFieldToRetainValue()
});
raises(function(){A.getFieldsWithRetainedValues()
});
raises(function(){A.hasRetainedValue()
});
A._hasRetainFeature=true;
ok(A.hasRetainFeature(),"Expected to have retain feature");
A.addFieldToRetainValue("summary");
A.addFieldToRetainValue("summary");
equals(A.getFieldsWithRetainedValues().join(","),"summary","Expected addFieldToRetainValue NOT to add duplicates");
ok(A.hasRetainedValue({id:"summary"}),"Expected [summary] value to be retained");
ok(!A.hasRetainedValue({id:"blah"}),"Expected [blah] value NOT to be retained");
A.removeFieldToRetainValue("summary");
ok(!A.hasRetainedValue({id:"summary"}),"Expected [summary] value NOT to be retained, it should have beenremoved")
});
test("mungeTabs",function(){var A=new JIRA.Forms.Model({userFieldsResource:"http://www.example.com",fieldsResource:"http://www.example.com"});
var B=A._mungeTabs([{id:"summary",tab:{label:"tab 2",position:2}},{id:"components",tab:{label:"tab 1",position:1}},{id:"version",tab:{label:"tab 0",position:0}}]);
deepEqual([{label:"tab 0",position:0,isFirst:true,fields:[{id:"version",tab:{label:"tab 0",position:0}}]},{label:"tab 1",position:1,fields:[{id:"components",tab:{label:"tab 1",position:1}}]},{label:"tab 2",position:2,fields:[{id:"summary",tab:{label:"tab 2",position:2}}]}],B)
});
test("updating user preferences",function(){expect(3);
var B=new JIRA.Forms.Model({userFieldsResource:"http://www.example.com",fieldsResource:"http://www.example.com"});
var A=["summary","components"],D=true,C=false;
B.userPreferences={};
B.userPreferences.fields=A;
B.userPreferences.showWelcomeScreen=D;
B.userPreferences.useQuickForm=C;
expectSuccessfulAjax();
B.updateUserPrefs({useQuickForm:true});
B.getUseConfigurableForm().done(function(E){ok(E,"Expected user pref useQuickForm to be updated")
});
B.getUserFields().done(function(E){deepEqual(A,E,"Expected user pref fields NOT to be changed")
});
expectSuccessfulAjax();
B.updateUserPrefs({fields:["versions","customfield"]});
B.getUserFields().done(function(E){deepEqual(["versions","customfield"],E,"Expected user pref fields NOT to be changed")
})
});